#include "common.h"

// data:0E32
const word strikeprob  [] = { 61,100, 61, 61, 61, 40,100,220,  0, 48, 32, 48};
// data:0E4A
const word restrikeprob[] = {  0,  0,  0,  5,  5,175, 16,  8,  0,255,255,150};
// data:0E62
const word blockprob   [] = {  0,150,150,200,200,255,200,250,  0,255,255,255};
// data:0E7A
const word impblockprob[] = {  0, 61, 61,100,100,145,100,250,  0,145,255,175};
// data:0E92
const word advprob     [] = {255,200,200,200,255,255,200,  0,  0,255,100,100};
// data:0EAA
const word refractimer [] = { 16, 16, 16, 16,  8,  8,  8,  8,  0,  8,  0,  0};
// data:0EC2
const word extrastrength[] = {0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0};
// data:0EDA
const byte tbl_guard_hp[] = {4, 3, 3, 3, 3, 4, 5, 4, 4, 5, 5, 5, 4, 6, 0, 0};
// data:34CA
word word_1E1AA;

// seg002:0000
void __pascal far do_init_shad(void *source,int seq_index) {
	memcpy_near(&char_, source, 7);
	seqtbl_offset_char(seq_index);
	char_.charid = charid_1_shadow;
	demo_time = 0;
	guard_skill = 3;
	guardhp_delta = guardhp_curr = guardhp_max = 4;
	saveshad();
}

// seg002:0044
void __pascal far get_guard_hp() {
	guardhp_delta = guardhp_curr = guardhp_max = extrastrength[guard_skill] + tbl_guard_hp[current_level];
}

// data:0EEA
const byte init_shad_6[] = {0x0F, 0x51, 0x76, 0, 0, 1, 0, 0};
// data:0EF2
const byte init_shad_5[] = {0x0F, 0x37, 0x37, 0, 0xFF, 0, 0, 0};
// data:0EFA
const byte init_shad_12[] = {0x0F, 0x51, 0xE8, 0, 0, 0, 0, 0};

// seg002:0064
void __pascal far check_shadow() {
	word_1EFCE = 0;
	if (current_level == 12) {
		// Special event: level 12 shadow
		if (!united_with_shadow && drawn_room == 15) {
			char_.room = drawn_room;
			if (get_tile(15, 1, 0) == tiles_22_sword) {
				return;
			}
			word_1EFD0 = 0;
			do_init_shad(&init_shad_12, 7 /*fall*/);
			return;
		}
	} else if (current_level == 6) {
		// Special event: level 6 shadow
		char_.room = drawn_room;
		if (char_.room == 1) {
			if (leveldoor_open == 0x4D) {
				play_sound(25); // presentation
				leveldoor_open = 0x4D;
			}
			do_init_shad(&init_shad_6, 2 /*stand*/);
			return;
		}
	} else if (current_level == 5) {
		// Special event: level 5 shadow
		char_.room = drawn_room;
		if (char_.room == 24) {
			if (get_tile(24, 3, 0) != tiles_10_potion) {
				return;
			}
			do_init_shad(&init_shad_5, 2 /*stand*/);
			return;
		}
	}
	enter_guard();
}

// seg002:0112
void __pascal far enter_guard() {
	word room_minus_1;
	word guard_tile;
	word frame;
	byte seq_hi;
	// arrays are indexed 0..23 instead of 1..24
	room_minus_1 = drawn_room - 1;
	frame = char_.frame; // hm?
	guard_tile = level.guards_tile[room_minus_1];
	if (guard_tile >= 30) return;
	char_.room = drawn_room;
	char_.curr_row = guard_tile / 10;
	char_.y = y_land[char_.curr_row + 1];
	char_.x = level.guards_x[room_minus_1];
	char_.curr_col = get_tile_div_mod_m7(char_.x);
	char_.direction = level.guards_dir[room_minus_1];
	// only regular guards have different colors (and only on VGA)
	if (graphics_mode == gmMcgaVga && tbl_guard_type[current_level] == 0) {
		curr_guard_color = level.guards_color[room_minus_1];
	} else {
		curr_guard_color = 0;
	}
	// level 3 has skeletons with infinite lives
	if (current_level == 3) {
		char_.charid = charid_4_skeleton;
	} else {
		char_.charid = charid_2_guard;
	}
	seq_hi = level.guards_seq_hi[room_minus_1];
	if (seq_hi == 0) {
		if (char_.charid == charid_4_skeleton) {
			char_.sword = 2;
			seqtbl_offset_char(63); // stand with sword
		} else {
			char_.sword = 0;
			seqtbl_offset_char(77); // stand
		}
	} else {
		char_.curr_seq = level.guards_seq_lo[room_minus_1] + (seq_hi << 8);
	}
	play_seq();
	guard_skill = level.guards_skill[room_minus_1];
	if (guard_skill >= 12) {
		guard_skill = 3;
	}
	frame = char_.frame;
	if (frame == 185 /*dead*/ || frame == 177 /*spiked*/ || frame == 178 /*chomped*/) {
		char_.alive = 1;
		draw_guard_hp(0, guardhp_curr);
		guardhp_curr = 0;
	} else {
		char_.alive = -1;
		word_1E1AA = 0;
		guard_refrac = 0;
		is_guard_notice = 0;
		get_guard_hp();
	}
	char_.fall_y = 0;
	char_.fall_x = 0;
	char_.action = actions_1_run_jump;
	saveshad();
}

// seg002:0269
void __pascal far check_guard_fallout() {
	if (guard.direction == dir_56_none || guard.y < 211) {
		return;
	}
	if (guard.charid == charid_1_shadow) {
		if (guard.action != 4) {
			return;
		}
		loadshad();
		clear_char();
		saveshad();
	} else if (guard.charid == charid_4_skeleton &&
		(guard.room = level.roomlinks[guard.room - 1].down) == 3) {
		// if skeleton falls down into room 3
		guard.x = 133;
		guard.curr_row = 1;
		guard.direction = dir_0_right;
		guard.alive = -1;
		leave_guard();
	} else {
		on_guard_killed();
		level.guards_tile[drawn_room - 1] = -1;
		guard.direction = dir_56_none;
		draw_guard_hp(0, guardhp_curr);
		guardhp_curr = 0;
	}
}

// seg002:02F5
void __pascal far leave_guard() {
	word room_minus_1;
	if (guard.direction == dir_56_none || guard.charid == charid_1_shadow || guard.charid == charid_24_mouse) {
		return;
	}
	// arrays are indexed 0..23 instead of 1..24
	room_minus_1 = guard.room - 1;
	level.guards_tile[room_minus_1] = get_tile_pos(0, guard.curr_row);
	level.guards_color[room_minus_1] = curr_guard_color;
	level.guards_x[room_minus_1] = guard.x;
	level.guards_dir[room_minus_1] = guard.direction;
	level.guards_skill[room_minus_1] = guard_skill;
	if (guard.alive < 0) {
		level.guards_seq_hi[room_minus_1] = 0;
	} else {
		level.guards_seq_lo[room_minus_1] = guard.curr_seq;
		level.guards_seq_hi[room_minus_1] = guard.curr_seq >> 8;
	}
	guard.direction = dir_56_none;
	draw_guard_hp(0, guardhp_curr);
	guardhp_curr = 0;
}

// seg002:039E
void __pascal far follow_guard() {
	level.guards_tile[kid.room - 1] = 0xFF;
	level.guards_tile[guard.room - 1] = 0xFF;
	loadshad();
	goto_other_room(roomleave_result);
	saveshad();
}

// seg002:03C7
void __pascal far exit_room() {
	word leave;
	word kid_room_m1;
	leave = 0;
	if (word_2088A != 0) {
		--word_2088A;
		return;
	}
	loadkid();
	load_frame_to_obj();
	set_char_collision();
	roomleave_result = leave_room();
	if (roomleave_result < 0) {
		return;
	}
	savekid();
	next_room = char_.room;
	if (guard.direction == dir_56_none) return;
	if (guard.alive < 0 && guard.sword == 2) {
		kid_room_m1 = kid.room - 1;
		if (level.guards_tile[kid_room_m1] >= 30 ||
			level.guards_seq_hi[kid_room_m1] != 0
		) {
			if (roomleave_result == 0) {
				// left
				if (guard.x >= 91) leave = 1;
			} else if (roomleave_result == 1) {
				// right
				if (guard.x < 165) leave = 1;
			} else if (roomleave_result == 2) {
				// up
				if (guard.curr_row >= 0) leave = 1;
			} else {
				// down
				if (guard.curr_row < 3) leave = 1;
			}
		} else {
			leave = 1;
		}
	} else {
		leave = 1;
	}
	if (leave) {
		leave_guard();
	} else {
		follow_guard();
	}
}

// seg002:0486
int __pascal far goto_other_room(short direction) {
	short opposite_dir;
	char_.room = ((byte*)&level.roomlinks[char_.room - 1])[direction];
	if (direction == 0) {
		// left
		char_.x += 140;
		opposite_dir = 1;
	} else if (direction == 1) {
		// right
		char_.x -= 140;
		opposite_dir = 0;
	} else if (direction == 2) {
		// up
		char_.y += 189;
		char_.curr_row = y_to_row_mod4(char_.y);
		opposite_dir = 3;
	} else {
		// down
		char_.y -= 189;
		char_.curr_row = y_to_row_mod4(char_.y);
		opposite_dir = 2;
	}
	return opposite_dir;
}

// seg002:0504
short __pascal far leave_room() {
	short frame;
	word action;
	short chary;
	short leave_dir;
	chary = char_.y;
	action = char_.action;
	frame = char_.frame;
	if (action != actions_5_bumped &&
		action != actions_4_in_freefall &&
		action != actions_3_in_midair &&
		(sbyte)chary < 10 && (sbyte)chary > -16
	) {
		leave_dir = 2; // up
	} else if (chary >= 211) {
		leave_dir = 3; // down
	} else if (
		// frames 135..149: climb up
		(frame >= 135 && frame < 150) ||
		// frames 110..119: standing up from crouch
		(frame >= 110 && frame < 120) ||
		// frames 150..162: with sword
		(frame >= 150 && frame < 163) ||
		// frames 166..168: with sword
		(frame >= 166 && frame < 169) ||
		action == actions_7_turn // turn
	) {
		return -1;
	} else if (char_.direction != dir_0_right) {
		if (char_x_left <= 54) {
			leave_dir = 0; // left
		} else if (char_x_left >= 198) {
			leave_dir = 1; // right
		} else {
			return -1;
		}
	} else {
		get_tile(char_.room, 9, char_.curr_row);
		if (curr_tile2 != tiles_7_doortop_with_floor &&
			curr_tile2 != tiles_12_doortop &&
			char_x_right >= 201
		) {
			leave_dir = 1; // right
		} else if (char_x_right <= 57) {
			leave_dir = 0; // left
		} else {
			return -1;
		}
	}
	switch (leave_dir) {
		case 0: // left
			play_mirr_mus();
			level3_set_chkp();
			Jaffar_exit();
		break;
		case 1: // right
			sword_disappears();
			meet_Jaffar();
		break;
		//case 2: // up
		case 3: // down
			// Special event: falling exit
			if (current_level == 6 && char_.room == 1) {
				return -2;
			}
		break;
	}
	goto_other_room(leave_dir);
	return leave_dir;
}

// seg002:0643
void __pascal far Jaffar_exit() {
	if (leveldoor_open == 2) {
		get_tile(24, 0, 0);
		trigger(0, 0, -1);
	}
}

// seg002:0665
void __pascal far level3_set_chkp() {
	// Special event: set checkpoint
	if (current_level == 3 && char_.room == 7) {
		checkpoint = 1;
		hitp_beg_lev = hitp_max;
	}
}

// seg002:0680
void __pascal far sword_disappears() {
	// Special event: sword disappears
	if (current_level == 12 && char_.room == 18) {
		get_tile(15, 1, 0);
		curr_room_tiles[curr_tile_pos] = tiles_1_floor;
	}
}

// seg002:06AE
void __pascal far meet_Jaffar() {
	// Special event: play music
	if (current_level == 13 && leveldoor_open == 0 && char_.room == 3) {
		play_sound(29); // meet Jaffar
		// Special event: Jaffar waits a bit (28/12=2.33 seconds)
		guard_notice_timer = 28;
	}
}

// seg002:06D3
void __pascal far play_mirr_mus() {
	// Special event: mirror music
	if (
		leveldoor_open != 0 &&
		leveldoor_open != 0x4D && // was the music played already?
		current_level == 4 &&
		char_.curr_row == 0 &&
		char_.room == 11
	) {
		play_sound(25); // presentation
		leveldoor_open = 0x4D;
	}
}

// seg002:0706
void __pascal far move_0_nothing() {
	control_shift = 0;
	control_y = 0;
	control_x = 0;
	control_shift2 = 0;
	control_down = 0;
	control_up = 0;
	control_backward = 0;
	control_forward = 0;
}

// seg002:0721
void __pascal far move_1_forward() {
	control_x = -1;
	control_forward = -1;
}

// seg002:072A
void __pascal far move_2_backward() {
	control_backward = -1;
	control_x = 1;
}

// seg002:0735
void __pascal far move_3_up() {
	control_y = -1;
	control_up = -1;
}

// seg002:073E
void __pascal far move_4_down() {
	control_down = -1;
	control_y = 1;
}

// seg002:0749
void __pascal far move_up_back() {
	control_up = -1;
	move_2_backward();
}

// seg002:0753
void __pascal far move_down_back() {
	control_down = -1;
	move_2_backward();
}

// seg002:075D
void __pascal far move_down_forw() {
	control_down = -1;
	move_1_forward();
}

// seg002:0767
void __pascal far move_6_shift() {
	control_shift = -1;
	control_shift2 = -1;
}

// seg002:0770
void __pascal far move_7() {
	control_shift = 0;
}

// seg002:0776
void __pascal far anim_opponent() {
	word charid;
	move_0_nothing();
	charid = char_.charid;
	if (charid == charid_0_kid) {
		anim_guard_4();
	} else {
		if (word_1E1AA) --word_1E1AA;
		if (kid_sword_strike) --kid_sword_strike;
		if (guard_refrac) --guard_refrac;
		if (charid == charid_24_mouse) {
			anim_mouse();
		} else if (charid == charid_4_skeleton) {
			anim_skeleton();
		} else if (charid == charid_1_shadow) {
			shadow_anim();
		} else if (current_level == 13) {
			anim_guard_3();
		} else {
			anim_guard_2();
		}
	}
}

// seg002:07EB
void __pascal far anim_mouse() {
	if (char_.direction == dir_56_none) {
		return;
	}
	if (char_.action == actions_0_stand) {
		if (char_.x >= 200) {
			clear_char();
		}
	} else {
		if (char_.x < 166) {
			seqtbl_offset_char(107); // mouse
			play_seq();
		}
	}
}

// seg002:081D
void __pascal far shadow_anim() {
	if (current_level == 4) {
		level4_shadow_anim();
	} else if (current_level == 5) {
		level5_shadow_anim();
	} else if (current_level == 6) {
		level6_shadow_anim();
	} else if (current_level == 12) {
		level12_shadow_anim();
	}
}

// seg002:0850
void __pascal far anim_skeleton() {
	char_.sword = 2;
	anim_guard_2();
}

// seg002:085A
void __pascal far anim_guard_3() {
	anim_guard_2();
}

// seg002:085F
void __pascal far anim_guard_4() {
	anim_guard_2();
}

// seg002:0864
void __pascal far anim_guard_2() {
	if (char_.sword < 2) {
		guard_notice();
	} else {
		anim_guard();
	}
}

// seg002:0876
void __pascal far guard_notice() {
	short distance;
	if (kid.alive >= 0) return;
	distance = char_opp_dist();
	if (opp.curr_row != char_.curr_row || (word)distance < (word)-8) {
		// If kid made a sound ...
		if (is_guard_notice) {
			is_guard_notice = 0;
			if (distance < 0) {
				// ... and kid is behind guard, guard turns around.
				if ((word)distance < (word)-4) {
					move_4_down();
				}
				return;
			}
		} else if (distance < 0) {
			return;
		}
	}
	if (can_guard_see_kid) {
		// If guard can see kid, guard moves to fighting pose.
		if (current_level != 13 || guard_notice_timer == 0) {
			move_down_forw();
		}
	}
}

// seg002:08DC
void __pascal far anim_guard() {
	short opp_frame;
	short char_frame;
	short distance;
	char_frame = char_.frame;
	if (char_frame != 166 && char_frame >= 150 && can_guard_see_kid != 1) {
		if (can_guard_see_kid == 0) {
			if (word_1EA12 != 0) {
				guard_follows_kid_down();
				//return;
			} else if (char_.charid != charid_4_skeleton) {
				move_down_back();
			}
			//return;
		} else { // can_guard_see_kid == 2
			opp_frame = opp.frame;
			distance = char_opp_dist();
			if (distance >= 12 &&
				// frames 102..117: falling and landing
				opp_frame >= 102 && opp_frame < 118 &&
				opp.action == actions_5_bumped
			) {
				return;
			}
			if (distance < 35) {
				if ((char_.sword < 2 && distance < 8) || distance < 12) {
					if (char_.direction == opp.direction) {
						// turn around
						move_2_backward();
						//return;
					} else {
						move_1_forward();
						//return;
					}
				} else {
					sub_4113(distance);
					//return;
				}
			} else {
				if (guard_refrac != 0) return;
				if (char_.direction != opp.direction) {
					// frames 7..14: running
					// frames 34..43: run-jump
					if (opp_frame >= 7 && opp_frame < 15) {
						if (distance < 40) move_6_shift();
						return;
					} else if (opp_frame >= 34 && opp_frame < 44) {
						if (distance < 50) move_6_shift();
						return;
						//return;
					}
				}
				sub_404B();
			}
			//...
		}
		//...
	}
}

// seg002:09CB
void __pascal far sub_404B() {
	if (tile_is_floor(get_tile_infrontof_char()) ||
		tile_is_floor(get_tile_infrontof2_char())) {
		move_1_forward();
	} else {
		move_2_backward();
	}
}

// seg002:09F8
void __pascal far guard_follows_kid_down() {
	// This is called from anim_guard, so char=guard, opp=kid
	word opp_action;
	opp_action = opp.action;
	if (opp_action == actions_2_hang_climb || opp_action == actions_6_hang_straight) {
		return;
	}
	if (// there is wall in front of guard
		wall_type(get_tile_infrontof_char()) != 0 ||
		(! tile_is_floor(curr_tile2) && (
			(get_tile(curr_room, tile_col, ++tile_row) == tiles_2_spike ||
			// guard would fall on loose floor
			curr_tile2 == tiles_11_loose ||
			// ... or wall (?)
			wall_type(curr_tile2) != 0 ||
			// ... or into a chasm
			! tile_is_floor(curr_tile2)) ||
			// ... or kid is not below
			char_.curr_row + 1 != opp.curr_row
		))
	) {
		// don't follow
		word_1EA12 = 0;
		move_2_backward();
	} else {
		// follow
		move_1_forward();
	}
}

// seg002:0A93
void __pascal far sub_4113(short distance) {
	if (opp.sword == 2) {
		sub_4141(distance);
	} else if (guard_refrac == 0) {
		if (distance < 29) {
			move_6_shift();
		} else {
			move_1_forward();
		}
	}
}

// seg002:0AC1
void __pascal far sub_4141(short distance) {
	if (distance < 10 || distance >= 29) {
		guard_advance();
	} else {
		guard_block();
		if (guard_refrac == 0) {
			if (distance < 12 || distance >= 29) {
				guard_advance();
			} else {
				guard_strike();
			}
		}
	}
}

// seg002:0AF5
void __pascal far guard_advance() {
	if (guard_skill == 0 || kid_sword_strike == 0) {
		if (advprob[guard_skill] > prandom(255)) {
			move_1_forward();
		}
	}
}

// seg002:0B1D
void __pascal far guard_block() {
	word opp_frame;
	opp_frame = opp.frame;
	if (opp_frame == 152 || opp_frame == 153 || opp_frame == 162) {
		if (word_1E1AA != 0) {
			if (impblockprob[guard_skill] > prandom(255)) {
				move_3_up();
			}
		} else {
			if (blockprob[guard_skill] > prandom(255)) {
				move_3_up();
			}
		}
	}
}

// seg002:0B73
void __pascal far guard_strike() {
	word opp_frame;
	word char_frame;
	opp_frame = opp.frame;
	if (opp_frame == 169 || opp_frame == 151) return;
	char_frame = char_.frame;
	if (char_frame == 161 || char_frame == 150) {
		if (restrikeprob[guard_skill] > prandom(255)) {
			move_6_shift();
		}
	} else {
		if (strikeprob[guard_skill] > prandom(255)) {
			move_6_shift();
		}
	}
}

// seg002:0BCD
void __pascal far hurt_by_sword() {
	short distance;
	if (char_.alive >= 0) return;
	if (char_.sword != 2) {
		// Being hurt when not in fighting pose means death.
		take_hp(100);
		seqtbl_offset_char(85); // dying
		loc_4276:
		if (get_tile_behind_char() != 0 ||
			(distance = distance_to_edge_weight()) < 4
		) {
			seqtbl_offset_char(85); // dying
			if (char_.charid != charid_0_kid &&
				char_.direction < dir_0_right && // looking left
				(curr_tile2 == tiles_4_gate || get_tile_at_char() == tiles_4_gate)
			) {
				char_.x = x_bump[tile_col - (curr_tile2 != tiles_4_gate) + 5] + 7;
				char_.x = char_dx_forward(10);
			}
			char_.y = y_land[char_.curr_row + 1];
			char_.fall_y = 0;
		} else {
			char_.x = char_dx_forward(distance - 20);
			load_fram_det_col();
			inc_curr_row();
			seqtbl_offset_char(81); // end jump and fall straight
		}
	} else {
		// You can't hurt skeletons
		if (char_.charid != charid_4_skeleton) {
			if (take_hp(1)) goto loc_4276;
		}
		seqtbl_offset_char(74); // being hit with sword
		char_.y = y_land[char_.curr_row + 1];
		char_.fall_y = 0;
	}
	// sound 13: kid hurt, sound 12: guard hurt
	play_sound(char_.charid == charid_0_kid ? 13 : 12);
	play_seq();
}

// seg002:0CD4
void __pascal far check_sword_hurt() {
	if (guard.action == actions_99_hurt) {
		if (kid.action == actions_99_hurt) {
			kid.action = actions_1_run_jump;
		}
		loadshad();
		hurt_by_sword();
		saveshad();
		guard_refrac = refractimer[guard_skill];
	} else {
		if (kid.action == actions_99_hurt) {
			loadkid();
			hurt_by_sword();
			savekid();
		}
	}
}

// seg002:0D1A
void __pascal far check_sword_hurting() {
	word kid_frame;
	kid_frame = kid.frame;
	// frames 217..228: go up on stairs
	if (kid_frame != 0 && (kid_frame < 219 || kid_frame >= 229)) {
		loadshad_and_opp();
		check_hurting();
		saveshad_and_opp();
		loadkid_and_opp();
		check_hurting();
		savekid_and_opp();
	}
}

// seg002:0D56
void __pascal far check_hurting() {
	short opp_frame, char_frame, distance, var_8;
	if (char_.sword != 2) return;
	if (char_.curr_row != opp.curr_row) return;
	char_frame = char_.frame;
	// frames 153..154: poking with sword
	if (char_frame != 153 && char_frame != 154) return;
	// If char is poking ...
	distance = char_opp_dist();
	opp_frame = opp.frame;
	// frames 161 and 150: parrying
	if (distance < 0 || distance >= 29 ||
		(opp_frame != 161 && opp_frame != 150)
	) {
		// ... and opp is not parrying
		// frame 154: poking
		if (char_.frame == 154) {
			if (opp.sword < 2) {
				var_8 = 8;
			} else {
				var_8 = 12;
			}
			distance = char_opp_dist();
			if (distance >= var_8 && distance < 29) {
				opp.action = actions_99_hurt;
			}
		}
	} else {
		opp.frame = 161;
		if (char_.charid != charid_0_kid) {
			word_1E1AA = 4;
		}
		seqtbl_offset_char(69); // hit with sword
		play_seq();
	}
	// frame 154: poking
	// frame 161: parrying
	if (char_.frame == 154 && opp.frame != 161 && opp.action != actions_99_hurt) {
		play_sound(11); // sword moving
	}
}

// seg002:0E1F
void __pascal far check_skel() {
	// Special event: skeleton wakes
	if (current_level == 3 &&
		guard.direction == dir_56_none &&
		drawn_room == 1 &&
		leveldoor_open != 0 &&
		(kid.curr_col == 2 || kid.curr_col == 3)
	) {
		get_tile(drawn_room, 5, 1);
		if (curr_tile2 == tiles_21_skeleton) {
			// erase skeleton
			curr_room_tiles[curr_tile_pos] = tiles_1_floor;
			redraw_height = 24;
			set_redraw_full(curr_tile_pos, 1);
			set_wipe(curr_tile_pos, 1);
			++curr_tile_pos;
			set_redraw_full(curr_tile_pos, 1);
			set_wipe(curr_tile_pos, 1);
			char_.room = drawn_room;
			char_.curr_row = 1;
			char_.y = y_land[char_.curr_row + 1];
			char_.curr_col = 5;
			char_.x = x_bump[char_.curr_col + 5] + 14;
			char_.direction = dir_FF_left;
			seqtbl_offset_char(88); // skel wake up
			play_seq();
			play_sound(44); // skel alive
			guard_skill = 2;
			char_.alive = -1;
			guardhp_max = guardhp_curr = 3;
			char_.fall_x = char_.fall_y = 0;
			is_guard_notice = guard_refrac = 0;
			char_.sword = 2;
			char_.charid = charid_4_skeleton;
			saveshad();
		}
	}
}

// seg002:0F3F
void __pascal far do_auto_moves(const auto_move_type *moves_ptr) {
	short demoindex;
	short curr_move;
	if (demo_time >= 0xFE) return;
	++demo_time;
	demoindex = demo_index;
	if (moves_ptr[demoindex].time <= demo_time) {
		++demo_index;
	} else {
		demoindex = demo_index - 1;
	}
	curr_move = moves_ptr[demoindex].move;
	switch (curr_move) {
		case -1:
			// this variable is not used anywhere else...
			/*
			if (word_1F9D6 != 0) {
				word_1F9D6 = 0;
			}
			*/
		break;
		case 0:
			move_0_nothing();
		break;
		case 1:
			move_1_forward();
		break;
		case 2:
			move_2_backward();
		break;
		case 3:
			move_3_up();
		break;
		case 4:
			move_4_down();
		break;
		case 5:
			move_3_up();
			move_1_forward();
		break;
		case 6:
			move_6_shift();
		break;
		case 7:
			move_7();
		break;
	}
}

// seg002:1000
void __pascal far level4_shadow_anim() {
	if (char_.room == 4) {
		if (char_.x < 80) {
			clear_char();
		} else {
			move_1_forward();
		}
	}
}

// data:0F02
const auto_move_type shad_drink_move[] = {
{0x00, 0},
{0x01, 1},
{0x0E, 0},
{0x12, 6},
{0x1D, 7},
{0x2D, 2},
{0x31, 1},
{0xFF,-2},
};

// seg002:101A
void __pascal far level5_shadow_anim() {
	if (char_.room == 24) {
		if (demo_time == 0) {
			get_tile(24, 1, 0);
			// is the door open?
			if (curr_room_modif[curr_tile_pos] < 80) return;
			demo_index = 0;
		}
		do_auto_moves(shad_drink_move);
		if (char_.x < 15) {
			clear_char();
		}
	}
}

// seg002:1064
void __pascal far level6_shadow_anim() {
	if (char_.room == 1 &&
		kid.frame == 43 && // a frame in run-jump
		kid.x < 128
	) {
		move_6_shift();
		move_1_forward();
	}
}

// seg002:1082
void __pascal far level12_shadow_anim() {
	short opp_frame;
	short xdiff;
	if (char_.room == 15 && word_1EFD0 == 0) {
		if (opp.x >= 150) {
			do_init_shad(&init_shad_12, 7 /*fall*/);
			return;
		}
		word_1EFD0 = 1;
	}
	if (char_.sword >= 2) {
		// if the kid puts his sword away, the shadow does the same,
		// but only if the shadow was already hurt (?)
		if (word_1EFCE == 0 || guard_refrac == 0) {
			anim_guard();
		} else {
			move_4_down();
		}
		return;
	}
	if (opp.sword >= 2 || word_1EFCE == 0) {
		if (can_guard_see_kid < 2 || (xdiff = char_opp_dist()) >= 90) {
			if (xdiff < 0) {
				move_2_backward();
			}
			return;
		}
		if (char_.frame == 15) {
			move_down_forw();
		}
		return;
	}
	if (char_opp_dist() < 10) {
		// unite with the shadow
		flash_color = 15; // white
		flash_time = 18;
		// get an extra HP for uniting the shadow
		add_life();
		// time of kid-shadow flash
		united_with_shadow = 42;
		// put the kid where the shadow was
		char_.charid = charid_0_kid;
		savekid();
		// remove the shadow
		clear_char();
		return;
	}
	if (can_guard_see_kid == 2) {
		// If kid runs to shadow, shadow runs to kid.
		opp_frame = opp.frame;
		// frames 1..14: running
		// frames 121..132: stepping
		if ((opp_frame >= 3 && opp_frame < 15) ||
			(opp_frame >= 127 && opp_frame < 133)
		) {
			move_1_forward();
		}
	}
}
