//#include "seg003.h"
//#include "seg009.h"
#include "common.h"

// data:3D1A
sbyte byte_1E9FA;

// seg003:0000
void __pascal far init_game(int level) {
	if(offscreen_surface) {
		free_surface(offscreen_surface); // missing in original
		offscreen_surface = NULL;
	}
	offscreen_surface = make_offscreen_buffer(&rect_top);
	load_kid_sprite();
	text_time_remaining = 0;
	text_time_total = 0;
	is_show_time = 0;
	checkpoint = 0;
	upside_down = 0;
	resurrect_time = 0;
	if (!need_reset_time) {
		rem_min = 60;
		rem_tick = 719;
		hitp_beg_lev = 3;
	}
	need_level1_music = (level == 1);
	play_level(level);
}

// data:0FA0
const cutscene_ptr_type tbl_cutscenes[16] = {
	NULL,
	NULL,
	cutscene_2_6,
	NULL,
	cutscene_4,
	NULL,
	cutscene_2_6,
	NULL,
	cutscene_8,
	cutscene_9,
	NULL,
	NULL,
	cutscene_12,
	NULL,
	NULL,
	NULL,
};

// seg003:005C
void __pascal far play_level(int level) {
	cutscene_ptr_type cutscene_func;
#ifdef USE_COPYPROT
	if (level == copyprot_level) {
		level = 15;
	}
#endif
	for (;;) {
		if (demo_mode && level > 2) {
			start_level = 0;
			word_1F05E = 1;
			start_game();
		}
		if (level != current_level) {
			if (level<0 || level>15) {
				printf("Tried to load cutscene for level %d, not in 0..15", level);
				quit(1);
			}
			cutscene_func = tbl_cutscenes[level];
			if (cutscene_func) {
				load_intro(level > 2, cutscene_func, 1);
			}
		}
		if (level != current_level) {
			load_lev_spr(level);
		}
		load_level();
		pos_guards();
		clear_coll_rooms();
		clear_saved_ctrl();
		drawn_room = 0;
		mobs_count = 0;
		trobs_count = 0;
		current_sound = -1;
		holding_sword = 0;
		word_1E18A = 0;
		can_guard_see_kid = 0;
		united_with_shadow = 0;
		flash_time = 0;
		leveldoor_open = 0;
		word_1F950 = 0;
		demo_index = 0;
		demo_time = 0;
		guardhp_curr = 0;
		hitp_delta = 0;
		guard.charid = charid_2_guard;
		guard.direction = dir_56_none;
		do_startpos();
		have_sword = (level != 1);
		find_start_level_door();
		// busy waiting?
		while (check_sound_playing() && !do_paused()) idle();
		stop_sounds();
		draw_level_first();
		show_copyprot(0);
		level = play_level_2();
		// hacked...
#ifdef USE_COPYPROT
		if (level == copyprot_level && !demo_mode) {
			level = 15;
		} else {
			if (level == 16) {
				level = copyprot_level;
				copyprot_level = -1;
			}
		}
#endif
		free_peels();
	}
}

// seg003:01A3
void __pascal far do_startpos() {
	word x;
	// Special event: start at checkpoint
	if (current_level == 3 && checkpoint) {
		level.start_dir = -1;
		level.start_room = 2;
		level.start_pos = 6;
		// Special event: remove loose floor
		get_tile(7, 4, 0);
		curr_room_tiles[curr_tile_pos] = tiles_0_empty;
	}
	next_room = char_.room = level.start_room;
	x = level.start_pos;
	char_.curr_col = x % 10;
	char_.curr_row = x / 10;
	char_.x = x_bump[char_.curr_col + 5] + 14;
	char_.direction = ~ level.start_dir;
	if (word_20566 == 0) {
		if (current_level != 0) {
			x = hitp_beg_lev;
		} else {
			// HP on demo level
			x = 4;
		}
		hitp_max = hitp_curr = x;
	}
	if (current_level == 1) {
		// Special event: press tile + falling entry
		get_tile(5, 2, 0);
		trigger(0, 0, -1);
		seqtbl_offset_char(7); // fall
	} else if (current_level == 13) {
		// Special event: running entry
		seqtbl_offset_char(84); // run
	} else {
		seqtbl_offset_char(5); // turn
	}
	set_start_pos();
}

// seg003:028A
void __pascal far set_start_pos() {
	char_.y = y_land[char_.curr_row + 1];
	char_.alive = -1;
	char_.charid = charid_0_kid;
	is_screaming = 0;
	knock = 0;
	upside_down = 0;
	is_feather_fall = 0;
	//word_1FB6E = 0; // this variable is not used anywhere else!
	char_.fall_y = 0;
	char_.fall_x = 0;
	word_1EFCE = 0;
	char_.sword = 0;
	word_1EA12 = 0;
	play_seq();
	if (current_level == 7 && char_.room == 17) {
		// Special event: level 7 falling entry
		// level 7, room 17: show room below
		goto_other_room(3);
	}
	savekid();
}

// seg003:02E6
void __pascal far find_start_level_door() {
	short tilepos;
	get_room_address(kid.room);
	for (tilepos = 0; tilepos < 30; ++tilepos) {
		if ((curr_room_tiles[tilepos] & 0x1F) == tiles_16_level_door_left) {
			start_level_door(kid.room, tilepos);
		}
	}
}

// seg003:0326
void __pascal far draw_level_first() {
	next_room = kid.room;
	check_the_end();
	if (tbl_level_type[current_level]) {
		gen_palace_wall_colors();
	}
	draw_rect(&screen_rect, 0);
	show_level();
	redraw_screen(0);
	draw_kid_hp(hitp_curr, hitp_max);
	// Busy waiting!
	//wait_time1 = 5;
	start_timer(1, 5);
	/*do {
		clear_kbd_buf();
	} while(wait_time1);*/
	//do_wait(1);
	do_simple_wait(1);
}

// seg003:037B
void __pascal far redraw_screen(int arg_0) {
	//remove_flash();
	if (arg_0) {
		draw_rect(&rect_top, 0);
	}
	different_room = 0;
	if (is_blind_mode) {
		draw_rect(&rect_top, 0);
	} else {
		if (curr_guard_color) {
			// Moved *before* drawings.
			set_chtab_palette(chtab_addrs[id_chtab_5_guard], &guard_palettes[0x30 * curr_guard_color - 0x30], 0x10);
		}
		need_drects = 0;
		redraw_room();
		if (is_keyboard_mode) {
			clear_kbd_buf();
		}
		is_blind_mode = 1;
		draw_tables();
		if (is_keyboard_mode) {
			clear_kbd_buf();
		}
#ifdef USE_COPYPROT
		if (current_level == 15) {
			// letters on potions level
			current_target_surface = offscreen_surface;
			short var_2;
			for (var_2 = 0; var_2 < 14; ++var_2) {
				if (copyprot_room[var_2] == drawn_room) {
					set_curr_pos((copyprot_tile[var_2] % 10 << 5) + 24, copyprot_tile[var_2] / 10 * 63 + 38);
					draw_text_character(copyprot_letter[cplevel_entr[var_2]]);
				}
			}
			current_target_surface = onscreen_surface_;
		}
#endif
		is_blind_mode = 0;
		memset_near(table_counts, 0, sizeof(table_counts));
		sub_B718();
		draw_tables();
		if (is_keyboard_mode) {
			clear_kbd_buf();
		}
		need_drects = 1;
		if (curr_guard_color) {
			//set_pal_arr(0x80, 0x10, &guard_palettes[0x30 * curr_guard_color - 0x30], 1);
		}
		if (upside_down) {
			flip_screen(offscreen_surface);
		}
		copy_screen_rect(&rect_top);
		if (upside_down) {
			flip_screen(offscreen_surface);
		}
		if (is_keyboard_mode) {
			clear_kbd_buf();
		}
	}
	word_2088A = 2;
}

// seg003:04F8
// Returns a level number:
// - The current level if it was restarted.
// - The next level if the level was completed.
int __pascal far play_level_2() {
	again:
	if (kid.sword == 2) {
		// speed when fighting (smaller is faster)
		//wait_time1 = 6;
		start_timer(1, 6);
	} else {
		// speed when not fighting (smaller is faster)
		//wait_time1 = 5;
		start_timer(1, 5);
	}
	guardhp_delta = 0;
	hitp_delta = 0;
	timers();
	play_frame();
	if (is_restart_level) {
		is_restart_level = 0;
		return current_level;
	} else {
		if (next_level == current_level || check_sound_playing()) {
			flash_if_hurt();
			draw_game_frame();
			remove_flash_if_hurt();
			// Busy waiting!
			//while (wait_time1 != 0);
			//do_wait(1);
			do_simple_wait(1);
			goto again;
		} else {
			stop_sounds();
			hitp_beg_lev = hitp_max;
			checkpoint = 0;
			return next_level;
		}
	}
}

// seg003:0576
void __pascal far redraw_at_char() {
	short x_top_row;
	short tile_col;
	short tile_row;
	short x_col_left;
	short x_col_right;
	if (char_.sword >= 2) {
		// If char is holding sword, it makes redraw-area bigger.
		if (char_.direction >= dir_0_right) {
			if (++char_col_right > 9) char_col_right = 9;
			// char_col_right = MIN(char_col_right + 1, 9);
		} else {
			if (--char_col_left < 0) char_col_left = 0;
			// char_col_left = MAX(char_col_left - 1, 0);
		}
	}
	if (char_.charid == charid_0_kid) {
		x_top_row = MIN(char_top_row, prev_char_top_row);
		x_col_right = MAX(char_col_right, prev_char_col_right);
		x_col_left = MIN(char_col_left, prev_char_col_left);
	} else {
		x_top_row = char_top_row;
		x_col_right = char_col_right;
		x_col_left = char_col_left;
	}
	for (tile_row = x_top_row; tile_row <= char_bottom_row; ++tile_row) {
		for (tile_col = x_col_left; tile_col <= x_col_right; ++tile_col) {
			set_redraw_fore(get_tile_pos(tile_col, tile_row), 1);
		}
	}
	if (char_.charid == charid_0_kid) {
		prev_char_top_row = char_top_row;
		prev_char_col_right = char_col_right;
		prev_char_col_left = char_col_left;
	}
}

// seg003:0645
void __pascal far redraw_at_char2() {
	short char_action;
	short char_frame;
	void __pascal (* redraw_func)(short, char);
	char_action = char_.action;
	char_frame = char_.frame;
	redraw_func = &set_redraw2;
	// frames 78..80: grab
	if (char_frame < 78 || char_frame >= 80) {
		// frames 135..149: climb up
		if (char_frame >= 137 && char_frame < 145) {
			redraw_func = &set_redraw_floor_overlay;
		} else {
			// frames 102..106: fall
			if (char_action != 2 && char_action != 3 && char_action != 4 && char_action != 6 && (char_action != 5 || char_frame < 102 || char_frame > 106)) {
				return;
			}
		}
	}
	for (tile_col = char_col_right; tile_col >= char_col_left; --tile_col) {
		if (char_action != 2) {
			redraw_func(get_tile_pos(tile_col, char_bottom_row), 1);
		}
		if (char_top_row != char_bottom_row) {
			redraw_func(get_tile_pos(tile_col, char_top_row), 1);
		}
	}
}

// seg003:0706
void __pascal far check_knock() {
	if (knock) {
		do_knock(char_.room, char_.curr_row - (knock>0));
		knock = 0;
	}
}

// seg003:0735
void __pascal far timers() {
	if (united_with_shadow > 0) {
		--united_with_shadow;
		if (united_with_shadow == 0) {
			--united_with_shadow;
		}
	}
	if (guard_notice_timer > 0) {
		--guard_notice_timer;
	}
	if (resurrect_time > 0) {
		--resurrect_time;
	}
	if (is_feather_fall && !check_sound_playing()) {
		is_feather_fall = 0;
	}
	// Special event: mouse
	if (current_level == 8 && char_.room == 16 && leveldoor_open) {
		++leveldoor_open;
		// time before mouse comes: 150/12=12.5 seconds
		if (leveldoor_open == 150) {
			do_mouse();
		}
	}
}

// seg003:0798
void __pascal far check_mirror() {
	word clip_top;
	if (jumped_through_mirror == -1) {
		jump_through_mirror();
	} else {
		if (get_tile_at_char() == tiles_13_mirror) {
			loadkid();
			load_frame();
			check_mirror_image();
			if (byte_1E9FA >= 0) {
				load_frame_to_obj();
				reset_obj_clip();
				clip_top = y_clip[char_.curr_row + 1];
				if (clip_top < obj_y) {
					obj_clip_top = clip_top;
					obj_clip_left = (char_.curr_col << 5) + 9;
					add_objtable(4); // mirror image
				}
			}
		}
	}
}

// seg003:080A
void __pascal far jump_through_mirror() {
	loadkid();
	load_frame();
	check_mirror_image();
	jumped_through_mirror = 0;
	char_.charid = charid_1_shadow;
	play_sound(45); // mirror
	saveshad();
	guardhp_max = guardhp_curr = hitp_max;
	hitp_curr = 1;
	draw_kid_hp(1, hitp_max);
	draw_guard_hp(guardhp_curr, guardhp_max);
}

// seg003:085B
void __pascal far check_mirror_image() {
	short distance;
	short xpos;
	xpos = x_bump[char_.curr_col + 5] + 10;
	distance = distance_to_edge_weight();
	if (char_.direction >= 0) {
		distance = (~distance) + 14;
	}
	byte_1E9FA = distance - 2;
	char_.x = (xpos << 1) - char_.x;
	char_.direction = ~char_.direction;
}

// seg003:08AA
void __pascal far bump_into_opponent() {
	// This is called from play_kid_frame, so char=kid, opp=guard
	short distance;
	if (can_guard_see_kid >= 2 &&
		char_.sword == 0 && // kid must not be in fighting pose
		opp.sword != 0 && // but guard must
		opp.action < 2 &&
		char_.direction != opp.direction // must be facing toward each other
	) {
		distance = char_opp_dist();
		if (ABS(distance) <= 15) {
			char_.y = y_land[char_.curr_row + 1];
			char_.fall_y = 0;
			seqtbl_offset_char(47); // bump
			play_seq();
		}
	}
}

// seg003:0913
void __pascal far pos_guards() {
	short guard_tile;
	short room1;
	for (room1 = 0; room1 < 24; ++room1) {
		guard_tile = level.guards_tile[room1];
		if (guard_tile < 30) {
			level.guards_x[room1] = x_bump[guard_tile % 10 + 5] + 14;
			level.guards_seq_hi[room1] = 0;
		}
	}
}

// seg003:0959
void __pascal far check_can_guard_see_kid() {
/*
Possible results in can_guard_see_kid:
0: guard can't see kid
1: guard can see kid, but won't come
2: guard can see kid, and will come
*/
	short kid_frame;
	short left_pos;
	short temp;
	short right_pos;
	kid_frame = kid.frame;
	if (guard.charid == charid_24_mouse) {
		return;
	}
	if ((guard.charid != charid_1_shadow || current_level == 12) &&
		// frames 217..228: going up on stairs
		kid_frame != 0 && (kid_frame < 219 || kid_frame >= 229) &&
		guard.direction != dir_56_none && kid.alive < 0 && guard.alive < 0 && kid.room == guard.room && kid.curr_row == guard.curr_row
	) {
		can_guard_see_kid = 2;
		left_pos = x_bump[kid.curr_col + 5] + 7;
		right_pos = x_bump[guard.curr_col + 5] + 7;
		if (left_pos > right_pos) {
			temp = left_pos;
			left_pos = right_pos;
			right_pos = temp;
		}
		// A chomper is on the left side of a tile, so it doesn't count.
		if (get_tile_at_kid(left_pos) == tiles_18_chomper) {
			left_pos += 14;
		}
		// A gate is on the right side of a tile, so it doesn't count.
		if (get_tile_at_kid(right_pos) == tiles_4_gate) {
			right_pos -= 14;
		}
		if (right_pos >= left_pos) {
			while (left_pos <= right_pos) {
				// Can't see through these tiles.
				if (get_tile_at_kid(left_pos) == tiles_20_wall ||
					curr_tile2 == tiles_7_doortop_with_floor ||
					curr_tile2 == tiles_12_doortop
				) {
					can_guard_see_kid = 0; return;
				}
				// Can see through these, but won't go through them.
				if (curr_tile2 == tiles_11_loose ||
					curr_tile2 == tiles_18_chomper ||
					(curr_tile2 == tiles_4_gate && curr_room_modif[curr_tile_pos] < 112) ||
					!tile_is_floor(curr_tile2)
				) {
					can_guard_see_kid = 1;
				}
				left_pos += 14;
			}
		}
	} else {
		can_guard_see_kid = 0;
	}
}

// seg003:0A99
byte __pascal far get_tile_at_kid(int xpos) {
	return get_tile(kid.room, get_tile_div_mod_m7(xpos), kid.curr_row);
}

// seg003:0ABA
void __pascal far do_mouse() {
	loadkid();
	char_.charid = charid_24_mouse;
	char_.x = 200;
	char_.curr_row = 0;
	char_.y = y_land[char_.curr_row + 1];
	char_.alive = -1;
	char_.direction = -1;
	guardhp_curr = 1;
	seqtbl_offset_char(105); // mouse forward
	play_seq();
	saveshad();
}

// seg003:0AFC
void __pascal far flash_if_hurt() {
	if (flash_time != 0) {
		do_flash(flash_color);
	} else if (hitp_delta < 0) {
		do_flash(12); // red
	}
}

// seg003:0B1A
void __pascal far remove_flash_if_hurt() {
	if (flash_time != 0) {
		--flash_time;
	} else {
		if (hitp_delta >= 0) return;
	}
	remove_flash();
}
