#include "common.h"

// data:1888
const word seqtbl_offsets[] = {
0x0000, 0x1973, 0x19A0, 0x1A93, 0x1ACD, 0x1B39, 0x1B5A, 0x1BDB,
0x1C54, 0x1CA1, 0x1D04, 0x1D25, 0x1D49, 0x1D4F, 0x1D68, 0x1DF6,
0x1C84, 0x202B, 0x1C1C, 0x1C01, 0x205A, 0x1C38, 0x209C, 0x1D36,
0x1C69, 0x1CD1, 0x1B04, 0x1B1A, 0x1D7D, 0x1F9E, 0x1F92, 0x1F82,
0x1F72, 0x1F5D, 0x1F48, 0x1F33, 0x1F19, 0x1F13, 0x1EF7, 0x1EDA,
0x1EBB, 0x1E9C, 0x1E7D, 0x1B53, 0x1E59, 0x1E06, 0x1E3B, 0x1DFC,
0x1D9B, 0x1FB3, 0x1FA7, 0x20BE, 0x20D1, 0x20D4, 0x20C9, 0x19C4,
0x1A13, 0x1A2E, 0x1A3C, 0x1A7C, 0x1A83, 0x1A63, 0x1A5E, 0x1A68,
0x1A6E, 0x1A75, 0x1A5A, 0x19F9, 0x1CEC, 0x1A54, 0x20DD, 0x20AE,
0x1E78, 0x1CDC, 0x19DC, 0x1A42, 0x1A07, 0x19A8, 0x2009, 0x1B1B,
0x1A8B, 0x1B85, 0x1BA1, 0x1BBF, 0x196E, 0x20A9, 0x1A22, 0x19A6,
0x19AC, 0x1B2D, 0x19C1, 0x1FCA, 0x1FDA, 0x1FFB, 0x2195, 0x2132,
0x214F, 0x2166, 0x2199, 0x21A8, 0x216D, 0x226E, 0x2136, 0x21BC,
0x1BFA, 0x2245, 0x2253, 0x225B, 0x21C4, 0x21C0, 0x21E6, 0x21EA,
0x21FC, 0x2240, 0x2257
};

// seg005:000A
void __pascal far seqtbl_offset_char(short seq_index) {
	char_.curr_seq = seqtbl_offsets[seq_index];
}

// seg005:001D
void __pascal far seqtbl_offset_opp(int seq_index) {
	opp.curr_seq = seqtbl_offsets[seq_index];
}

// seg005:0030
void __pascal far do_fall() {
	if (is_screaming == 0 && char_.fall_y >= 31) {
		play_sound(1); // falling
		is_screaming = 1;
	}
	if (y_land[char_.curr_row + 1] > char_.y) {
		check_hang();
	} else {
		if (get_tile_at_char() == tiles_20_wall) {
			in_wall();
		}
		if (tile_is_floor(curr_tile2)) {
			land();
		} else {
			inc_curr_row();
		}
	}
}

// seg005:0090
void __pascal far land() {
	word seq_id;
	is_screaming = 0;
	char_.y = y_land[char_.curr_row + 1];
	if (get_tile_at_char() != tiles_2_spike) {
		if (! tile_is_floor(get_tile_infrontof_char()) &&
			distance_to_edge_weight() < 3
		) {
			char_.x = char_dx_forward(-3);
		}
		start_chompers();
	} else {
		goto loc_5EE6;
	}
	if (char_.alive < 0) {
		if ((distance_to_edge_weight() >= 12 &&
			get_tile_behind_char() == tiles_2_spike) ||
			get_tile_at_char() == tiles_2_spike
		) {
			loc_5EE6:
			if (is_spike_harmful()) {
				spiked();
				return;
			}
		}
		{
			if (char_.fall_y < 22) {
				loc_5EFD:
				if (char_.charid >= charid_2_guard || char_.sword == 2) {
					char_.sword = 2;
					seq_id = 63; // stand with sword
				} else {
					seq_id = 17; // crouch
				}
				if (char_.charid == charid_0_kid) {
					play_sound(17); // landing soft
					is_guard_notice = 1;
				}
			} else if (char_.fall_y < 33) {
				if (char_.charid == charid_1_shadow) goto loc_5EFD;
				if (char_.charid == charid_2_guard) goto loc_5F6C;
				if (! take_hp(1)) {
					play_sound(16); // landing medium
					is_guard_notice = 1;
					seq_id = 20; // hard land
				} else {
					goto loc_5F75;
				}
			} else {
				goto loc_5F6C;
			}
		}
	} else {
		loc_5F6C:
		take_hp(100);
		loc_5F75:
		play_sound(0); // prince crashing into the floor
		seq_id = 22; // dead
	}
	seqtbl_offset_char(seq_id);
	play_seq();
	char_.fall_y = 0;
}

// seg005:01B7
void __pascal far spiked() {
	curr_room_modif[curr_tile_pos] = 0xFF;
	char_.y = y_land[char_.curr_row + 1];
	char_.x = x_bump[tile_col + 5] + 10;
	char_.x = char_dx_forward(8);
	char_.fall_y = 0;
	play_sound(48); // something spiked
	take_hp(100);
	seqtbl_offset_char(51); // spiked
	play_seq();
}

// seg005:0213
void __pascal far control() {
	short char_frame;
	short char_action;
	char_frame = char_.frame;
	if (char_.alive >= 0) {
		if (char_frame == 15 || // stand
			char_frame == 166 || // stand
			char_frame == 158 || // stand with sword
			char_frame == 171 // stand with sword
		) {
			seqtbl_offset_char(71); // dying
		}
	} else {
		char_action = char_.action;
		if (char_action == actions_5_bumped ||
			char_action == actions_4_in_freefall
		) {
			release_arrows();
		} else if (char_.sword == 2) {
			control_with_sword();
		} else if (char_.charid >= charid_2_guard) {
			stand_flipped();
		} else if (char_frame == 15 || // standing
			(char_frame>=50 && char_frame<53) // end of turning
		) {
			do_control();
		} else if (char_frame == 48) { // a frame in turning
			start_run();
		} else if (char_frame < 4) { // start run
			control_startrun();
		} else if (char_frame >= 67 && char_frame < 70) { // start jump up
			control_jumpup();
		} else if (char_frame < 15) { // running
			while_running();
		} else if (char_frame >= 87 && char_frame < 100) { // hanging
			control_hanging();
		} else if (char_frame == 109) { // crouching
			crouched();
		}
	}
}

// seg005:02EB
void __pascal far crouched() {
	if (need_level1_music != 0 && current_level == 1) {
		// Special event: music when crouching
		if (! check_sound_playing()) {
			if (need_level1_music == 1) {
				play_sound(25); // presentation
				need_level1_music = 2;
			} else {
				need_level1_music = 0;
			}
		}
	} else {
		need_level1_music = 0;
		if (control_shift2 < 0 && check_get_item()) return;
		if (control_y != 1) {
			seqtbl_offset_char(49); // crouch and stand up
		} else {
			if (control_forward < 0) {
				control_forward = 1; // disable automatic repeat
				seqtbl_offset_char(79); // frog hop
			}
		}
	}
}

// seg005:0358
void __pascal far do_control() {
	short var_2;
	if (control_shift2 < 0 && control_shift < 0 && check_get_item()) {
		return;
	}
	if (char_.charid != charid_0_kid && control_down < 0 && control_forward < 0) {
		draw_sword();
		return;
	} //else
	if (have_sword) {
		if (word_1EFCE != 0 && control_shift >= 0) goto loc_6213;
		if (can_guard_see_kid >= 2) {
			var_2 = char_opp_dist();
			if (var_2 >= -10 && var_2 < 90) {
				holding_sword = 1;
				if ((word)var_2 < (word)-6) {
					if (opp.charid == charid_1_shadow &&
						(opp.action == actions_3_in_midair || (opp.frame >= 107 && opp.frame < 118))
					) {
						word_1EFCE = 0;
					} else {
						draw_sword();
						return;
					}
				} else {
					back_pressed();
					return;
				}
			}
		} else {
			word_1EFCE = 0;
		}
	}
	if (control_shift < 0) {
		if (control_backward < 0) {
			back_pressed();
		} else if (control_up < 0) {
			up_pressed();
		} else if (control_down < 0) {
			down_pressed();
		} else if (control_x < 0 && control_forward < 0) {
			safe_step();
		}
	} else loc_6213: if (control_forward < 0) {
		if (is_keyboard_mode && control_up < 0) {
			jump_fwd();
		} else {
			forward_pressed();
		}
	} else if (control_backward < 0) {
		back_pressed();
	} else if (control_up < 0) {
		if (is_keyboard_mode && control_forward < 0) {
			jump_fwd();
		} else {
			up_pressed();
		}
	} else if (control_down < 0) {
		down_pressed();
	} else if (control_x < 0) {
		forward_pressed();
	}
}

// seg005:0482
void __pascal far up_pressed() {
	if ((get_tile_at_char() == tiles_16_level_door_left ||
		get_tile_behind_char() == tiles_16_level_door_left ||
		get_tile_infrontof_char() == tiles_16_level_door_left) &&
		level.start_room != drawn_room &&
		leveldoor_open
	){
		go_up_leveldoor();
	} else {
		if (control_x < 0) {
			jump_fwd();
		} else {
			check_jump_up();
		}
	}
}

// seg005:04C7
void __pascal far down_pressed() {
	control_down = 1; // disable automatic repeat
	if (! tile_is_floor(get_tile_infrontof_char()) &&
		distance_to_edge_weight() < 3
	) {
		char_.x = char_dx_forward(5);
		load_fram_det_col();
	} else {
		if (! tile_is_floor(get_tile_behind_char()) &&
			distance_to_edge_weight() >= 8
		) {
			through_tile = get_tile_behind_char();
			get_tile_at_char();
			if (can_grab() &&
				(char_.direction >= dir_0_right ||
				get_tile_at_char() != tiles_4_gate ||
				curr_room_modif[curr_tile_pos] >> 2 >= 6)
			) {
				char_.x = char_dx_forward(distance_to_edge_weight() - 9);
				seqtbl_offset_char(68); // climb down, hang and drop
			} else {
				crouch();
			}
		} else {
			crouch();
		}
	}
}

// seg005:0574
void __pascal far go_up_leveldoor() {
	char_.x = x_bump[tile_col + 5] + 10;
	char_.direction = dir_FF_left; // right
	seqtbl_offset_char(70); // go up on level door
}

// seg005:058F
void __pascal far start_run() {
	if (control_shift >= 0 && control_x < 0 && control_y >= 0) {
		seqtbl_offset_char(43); // start run and run
	}
}

// seg005:05AD
void __pascal far crouch() {
	seqtbl_offset_char(50); // crouch
	control_down = release_arrows();
}

// seg005:05BE
void __pascal far back_pressed() {
	word seq_id;
	control_backward = release_arrows();
	// After turn, kid will draw sword if ...
	if (have_sword == 0 || // if kid has sword
		can_guard_see_kid < 2 || // and can see guard
		char_opp_dist() > 0 || // and guard was behind him
		distance_to_edge_weight() < 2
	) {
		seq_id = 5; // turn
	} else {
		char_.sword = 2;
		word_1EFCE = 0;
		seq_id = 89; // turn and draw sword
	}
	seqtbl_offset_char(seq_id);
}

// seg005:060F
void __pascal far forward_pressed() {
	short distance;
	distance = get_some_tile();
	if (byte_21271 == 1 && curr_tile2 != tiles_18_chomper && distance < 8) {
		// If char is near a wall, step instead of run.
		if (control_forward < 0) {
			safe_step();
		}
	} else {
		seqtbl_offset_char(1); // start run and run
	}
}

// seg005:0649
void __pascal far while_running() {
	if (control_x == 0 && (char_.frame == 7 || char_.frame == 11)) {
		control_forward = release_arrows();
		seqtbl_offset_char(13); // stop run
	} else if (control_x > 0) {
		control_backward = release_arrows();
		seqtbl_offset_char(6); // run-turn
	} else if (control_y < 0 && control_up < 0) {
		run_jump();
	} else if (control_down < 0) {
		control_down = 1; // disable automatic repeat
		seqtbl_offset_char(26); // crouch forward
	}
}

// seg005:06A8
void __pascal far safe_step() {
	short distance;
	control_shift2 = 1; // disable automatic repeat
	control_forward = 1; // disable automatic repeat
	distance = get_some_tile();
	if (distance) {
		char_.repeat = 1;
		seqtbl_offset_char(distance + 28); // 29..42: safe step
	} else if (byte_21271 != 1 && char_.repeat != 0) {
		char_.repeat = 0;
		seqtbl_offset_char(44); // step on edge
	} else {
		seqtbl_offset_char(39); // safe step
	}
}

// seg005:06F0
int __pascal far check_get_item() {
	if (get_tile_at_char() == tiles_10_potion ||
		curr_tile2 == tiles_22_sword
	) {
		if (! tile_is_floor(get_tile_behind_char())) {
			return 0;
		}
		char_.x = char_dx_forward(-14);
		load_fram_det_col();
	}
	if (get_tile_infrontof_char() == tiles_10_potion ||
		curr_tile2 == tiles_22_sword
	) {
		get_item();
		return 1;
	}
	return 0;
}

// seg005:073E
void __pascal far get_item() {
	short distance;
	if (char_.frame != 109) { // crouching
		distance = get_some_tile();
		if (byte_21271 != 2) {
			char_.x = char_dx_forward(distance);
		}
		if (char_.direction >= dir_0_right) {
			char_.x = char_dx_forward((curr_tile2 == tiles_10_potion) - 2);
		}
		crouch();
	} else if (curr_tile2 == tiles_22_sword) {
		do_pickup(-1);
		seqtbl_offset_char(91); // get sword
	} else { // potion
		do_pickup(curr_room_modif[curr_tile_pos] >> 5);
		seqtbl_offset_char(78); // drink
#ifdef USE_COPYPROT
		if (current_level == 15) {
			short index;
			for (index = 0; index < 14; ++index) {
				// remove letter on potions level
				if (copyprot_room[index] == curr_room &&
					copyprot_tile[index] == curr_tile_pos
				) {
					copyprot_room[index] = 0;
					break;
				}
			}
		}
#endif
	}
}

// seg005:07FF
void __pascal far control_startrun() {
	if (control_y < 0 && control_x < 0) {
		jump_fwd();
	}
}

// seg005:0812
void __pascal far control_jumpup() {
	if (control_x < 0 || control_forward < 0) {
		jump_fwd();
	}
}

// seg005:0825
void __pascal far jump_fwd() {
	control_up = control_forward = 1; // disable automatic repeat
	seqtbl_offset_char(3); // jump
}

// seg005:0836
void __pascal far check_jump_up() {
	control_up = release_arrows();
	through_tile = get_tile_above_char();
	get_tile_front_above_char();
	if (can_grab()) {
		jump_up_hang_drop();
	} else {
		through_tile = get_tile_behind_above_char();
		get_tile_above_char();
		if (can_grab()) {
			jump_up();
		} else {
			jump_up2();
		}
	}
}

// seg005:087B
void __pascal far jump_up() {
	short distance;
	distance = distance_to_edge_weight();
	if (distance < 6) {
		jump_up2();
	} else if (! tile_is_floor(get_tile_behind_char())) {
		// There is not floor behind char.
		jump_up_hang();
	} else {
		// There is floor behind char, go back a bit.
		char_.x = char_dx_forward(distance - 14);
		load_fram_det_col();
		jump_up_hang_drop();
	}
}

// seg005:08C7
void __pascal far jump_up_hang() {
	get_tile_above_char();
	char_.x = char_dx_forward(distance_to_edge_weight() - 10);
	seqtbl_offset_char(16); // jump up, hang and drop
}

// seg005:08E6
void __pascal far jump_up2() {
	short distance;
	control_up = release_arrows();
	distance = get_some_tile();
	if (distance < 4 && byte_21271 == 1) {
		char_.x = char_dx_forward(distance - 3);
	}
	get_tile(char_.room, get_tile_div_mod(forward_delta_x(0) + dx_weight() - 6), char_.curr_row - 1);
	if (curr_tile2 != tiles_20_wall && ! tile_is_floor(curr_tile2)) {
		seqtbl_offset_char(28); // jump up with nothing above
	} else {
		seqtbl_offset_char(14); // jump up with wall above
	}
}

// seg005:0968
void __pascal far control_hanging() {
	if (char_.alive < 0) {
		if (word_1E18A == 0 && control_y < 0) {
			can_climb_up();
		} else if (control_shift < 0) {
			// hanging against a wall or a doortop
			if (char_.action != actions_6_hang_straight &&
				(get_tile_at_char() == tiles_20_wall ||
				(char_.direction == dir_FF_left && ( // facing left
					curr_tile2 == tiles_7_doortop_with_floor ||
					curr_tile2 == tiles_12_doortop
				)))
			) {
				if (word_1E18A == 0) {
					play_sound(8); // touching a wall
				}
				seqtbl_offset_char(25); // hang against wall
			} else {
				if (! tile_is_floor(get_tile_above_char())) {
					hang_fall();
				}
			}
		} else {
			hang_fall();
		}
	} else {
		hang_fall();
	}
}

// seg005:09DF
void __pascal far can_climb_up() {
	short seq_id;
	seq_id = 10; // climb up
	control_up = control_shift2 = release_arrows();
	get_tile_above_char();
	if (((curr_tile2 == tiles_13_mirror || curr_tile2 == tiles_18_chomper) &&
		char_.direction == dir_0_right) ||
		(curr_tile2 == tiles_4_gate && char_.direction != dir_0_right &&
		curr_room_modif[curr_tile_pos] >> 2 < 6)
	) {
		seq_id = 73; // climb up to closed gate and down
	}
	seqtbl_offset_char(seq_id);
}

// seg005:0A46
void __pascal far hang_fall() {
	control_down = release_arrows();
	if (! tile_is_floor(get_tile_behind_char()) &&
		! tile_is_floor(get_tile_at_char())
	) {
		seqtbl_offset_char(23); // hang and fall straight
	} else {
		if (get_tile_at_char() == tiles_20_wall ||
			(char_.direction < dir_0_right && ( // looking left
				curr_tile2 == tiles_7_doortop_with_floor ||
				curr_tile2 == tiles_12_doortop
			))
		) {
			char_.x = char_dx_forward(-7);
		}
		seqtbl_offset_char(11); // end of climb down
	}
}

// seg005:0AA8
void __pascal far jump_up_hang_drop() {
	short distance;
	distance = distance_to_edge_weight();
	if (distance < 4 && get_some_tile() < 4 && byte_21271 != 1) {
		char_.x = char_dx_forward(distance);
		seqtbl_offset_char(8); // jump up, hang and drop
	} else {
		char_.x = char_dx_forward(distance - 4);
		seqtbl_offset_char(24); // jump up, hang and drop
	}
}

// seg005:0AF7
void __pascal far run_jump() {
	short var_2;
	short xpos;
	short col;
	short var_8;
	if (char_.frame >= 7) {
		// Align kid to edge of floor.
		xpos = char_dx_forward(4);
		col = get_tile_div_mod_m7(xpos);
		for (var_2 = 0; var_2 < 2; ++var_2) {
			col += dir_front[char_.direction + 1];
			get_tile(char_.room, col, char_.curr_row);
			if (curr_tile2 == tiles_2_spike || ! tile_is_floor(curr_tile2)) {
				var_8 = distance_to_edge(xpos) + 14 * var_2 - 14;
				if ((word)var_8 < (word)-8 || var_8 >= 2) {
					if (var_8 < 128) return;
					var_8 = -3;
				}
				char_.x = char_dx_forward(var_8 + 4);
				break;
			}
		}
		control_up = release_arrows(); // disable automatic repeat
		seqtbl_offset_char(4); // run-jump
	}
}

// sseg005:0BB5
void __pascal far back_with_sword() {
	short frame;
	frame = char_.frame;
	if (frame == 158 || frame == 170 || frame == 171) {
		control_backward = 1; // disable automatic repeat
		seqtbl_offset_char(57); // back with sword
	}
}

// seg005:0BE3
void __pascal far fwd_with_sword() {
	short frame;
	frame = char_.frame;
	if (frame == 158 || frame == 170 || frame == 171) {
		control_forward = 1; // disable automatic repeat
		if (char_.charid != charid_0_kid) {
			seqtbl_offset_char(56); // forward with sword
		} else {
			seqtbl_offset_char(86); // forward with sword
		}
	}
}

// seg005:0C1D
void __pascal far draw_sword() {
	word seq_id;
	seq_id = 55; // draw sword
	control_forward = control_shift2 = release_arrows();
	if (char_.charid == charid_0_kid) {
		play_sound(19); // taking_out_the_sword
		word_1EFCE = 0;
	} else if (char_.charid != charid_1_shadow) {
		seq_id = 90; // stand with sword
	}
	char_.sword = 2;
	seqtbl_offset_char(seq_id);
}

// seg005:0C67
void __pascal far control_with_sword() {
	short distance;
	if (char_.action < actions_2_hang_climb) {
		if (get_tile_at_char() == tiles_11_loose || can_guard_see_kid >= 2) {
			distance = char_opp_dist();
			if ((word)distance < (word)90) {
				swordfight();
				return;
			} else if (distance < 0) {
				if ((word)distance < (word)-4) {
					seqtbl_offset_char(60); // being hit? with sword
					return;
				} else {
					swordfight();
					return;
				}
			}
		} /*else*/ {
			if (char_.charid == charid_0_kid && char_.alive < 0) {
				holding_sword = 0;
			}
			if (char_.charid < charid_2_guard) {
				// frame 171: stand with sword
				if (char_.frame == 171) {
					char_.sword = 0;
					seqtbl_offset_char(92); // put sword away
				}
			} else {
				swordfight();
			}
		}
	}
}

// seg005:0CDB
void __pascal far swordfight() {
	short frame;
	short seq_id;
	short charid;
	frame = char_.frame;
	charid = char_.charid;
	// frame 161: parry
	if (frame == 161 && control_shift2 >= 0) {
		seqtbl_offset_char(57); // back with sword
		return;
	} else if (control_shift2 < 0) {
		if (charid == charid_0_kid) {
			kid_sword_strike = 15;
		}
		sword_strike();
		if (control_shift2 == 1) return;
	}
	if (control_down < 0) {
		if (frame == 158 || frame == 170 || frame == 171) {
			control_down = 1; // disable automatic repeat
			char_.sword = 0;
			if (charid == charid_0_kid) {
				word_1EFCE = 1;
				guard_refrac = 9;
				holding_sword = 0;
				seq_id = 93; // put sword away fast
			} else if (charid == charid_1_shadow) {
				seq_id = 92; // put sword away
			} else {
				seq_id = 87; // stand
			}
			seqtbl_offset_char(seq_id);
		}
	} else if (control_up < 0) {
		parry();
	} else if (control_forward < 0) {
		fwd_with_sword();
	} else if (control_backward < 0) {
		back_with_sword();
	}
}

// seg005:0DB0
void __pascal far sword_strike() {
	short frame;
	short seq_id;
	frame = char_.frame;
	if (frame == 157 || // walk with sword
		frame == 158 || // stand with sword
		frame == 170 || // stand with sword
		frame == 171 || // stand with sword
		frame == 165 // walk with sword
	) {
		if (char_.charid == charid_0_kid) {
			seq_id = 75; // hit with sword
		} else {
			seq_id = 58; // strike with sword
		}
	} else if (frame == 150 || frame == 161) { // parry
		seq_id = 66; // defend and hit with sword
	} else {
		return;
	}
	control_shift2 = 1; // disable automatic repeat
	seqtbl_offset_char(seq_id);
}

// seg005:0E0F
void __pascal far parry() {
	short opp_frame;
	short char_frame;
	short var_6;
	short seq_id;
	short char_charid;
	char_frame = char_.frame;
	opp_frame = opp.frame;
	char_charid = char_.charid;
	seq_id = 62; // defend with sword
	var_6 = 0;
	if (
		char_frame == 158 || // stand with sword
		char_frame == 170 || // stand with sword
		char_frame == 171 || // stand with sword
		char_frame == 168 || // back?
		char_frame == 165 // walk with sword
	) {
		if (char_opp_dist() >= 32 && char_charid == charid_0_kid) {
			back_with_sword();
		} else if (char_charid == charid_0_kid) {
			if (opp_frame == 168) return;
			if (opp_frame != 151 &&
				opp_frame != 152 &&
				opp_frame != 162
			) {
				if (opp_frame == 153) { // strike
					var_6 = 1;
				}
				if (char_charid != charid_0_kid) {
					back_with_sword();
					return;
				}
			}
		} else {
			if (opp_frame != 152) return;
		}
	} else {
		if (opp_frame != 167) return;
		seq_id = 61; // defend? with sword
	}
	control_up = 1; // disable automatic repeat
	seqtbl_offset_char(seq_id);
	if (var_6) {
		play_seq();
	}
}
