//#include "seg007.h"
#include "common.h"

// seg007:0000
void __pascal far process_trobs() {
	word need_delete;
	word index;
	word new_index;
	need_delete = 0;
	if (trobs_count == 0) return;
	for (index = 0; index < trobs_count; ++index) {
		trob = trobs[index];
		animate_tile();
		trobs[index].type = trob.type;
		if (trob.type < 0) {
			need_delete = 1;
		}
	}
	if (need_delete) {
		for (index = new_index = 0; index < trobs_count; ++index) {
			if (trobs[index].type >= 0) {
				trobs[new_index++] = trobs[index];
			}
		}
		trobs_count = new_index;
	}
}

// seg007:00AF
void __pascal far animate_tile() {
	get_room_address(trob.room);
	switch (get_curr_tile(trob.tile)) {
		case tiles_19_torch:
		case tiles_30_torch_with_debris:
			animate_torch();
		break;
		case tiles_6_closer:
		case tiles_15_opener:
			animate_button();
		break;
		case tiles_2_spike:
			animate_spike();
		break;
		case tiles_11_loose:
			animate_loose();
		break;
		case tiles_0_empty:
			animate_empty();
		break;
		case tiles_18_chomper:
			animate_chomper();
		break;
		case tiles_4_gate:
			animate_door();
		break;
		case tiles_16_level_door_left:
			animate_leveldoor();
		break;
		case tiles_10_potion:
			animate_potion();
		break;
		case tiles_22_sword:
			animate_sword();
		break;
		default:
			trob.type = -1;
		break;
	}
	curr_room_modif[trob.tile] = curr_modifier;
}

// seg007:0166
short __pascal far is_trob_in_drawn_room() {
	if (trob.room != drawn_room) {
		trob.type = -1;
		return 0;
	} else {
		return 1;
	}
}

// seg007:017E
void __pascal far set_redraw_anim_right() {
	set_redraw_anim(get_trob_right_pos_in_drawn_room(), 1);
}

// seg007:018C
void __pascal far set_redraw_anim_curr() {
	set_redraw_anim(get_trob_pos_in_drawn_room(), 1);
}

// seg007:019A
void __pascal far redraw_at_trob() {
	word tile_pos;
	redraw_height = 63;
	tile_pos = get_trob_pos_in_drawn_room();
	set_redraw_full(tile_pos, 1);
	set_wipe(tile_pos, 1);
}

// seg007:01C5
void __pascal far redraw_21h() {
	redraw_height = 0x21;
	redraw_tile_height();
}

// seg007:01D0
void __pascal far redraw_11h() {
	redraw_height = 0x11;
	redraw_tile_height();
}

// seg007:01DB
void __pascal far redraw_20h() {
	redraw_height = 0x20;
	redraw_tile_height();
}

// seg007:01E6
void __pascal far draw_trob() {
	word var_2;
	var_2 = get_trob_right_pos_in_drawn_room();
	set_redraw_anim(var_2, 1);
	set_redraw_fore(var_2, 1);
	set_redraw_anim(get_trob_right_above_pos_in_drawn_room(), 1);
}

// seg007:0218
void __pascal far redraw_tile_height() {
	short tile_pos;
	tile_pos = get_trob_pos_in_drawn_room();
	set_redraw_full(tile_pos, 1);
	set_wipe(tile_pos, 1);
	tile_pos = get_trob_right_pos_in_drawn_room();
	set_redraw_full(tile_pos, 1);
	set_wipe(tile_pos, 1);
}

// seg007:0258
short __pascal far get_trob_pos_in_drawn_room() {
	short tile_pos;
	tile_pos = trob.tile;
	if (trob.room == room_A) {
		if (tile_pos >= 20 && tile_pos < 30) {
			// 20..29 -> -1..-10
			tile_pos = 19 - tile_pos;
		} else {
			tile_pos = 30;
		}
	} else {
		if (trob.room != drawn_room) {
			tile_pos = 30;
		}
	}
	return tile_pos;
}

// seg007:029D
short __pascal far get_trob_right_pos_in_drawn_room() {
	word tile_pos;
	tile_pos = trob.tile;
	if (trob.room == drawn_room) {
		if (tile_pos % 10 != 9) {
			++tile_pos;
		} else {
			tile_pos = 30;
		}
	} else if (trob.room == room_L) {
		if (tile_pos % 10 == 9) {
			tile_pos -= 9;
		} else {
			tile_pos = 30;
		}
	} else if (trob.room == room_A) {
		if (tile_pos >= 20 && tile_pos < 29) {
			// 20..28 -> -2..-10
			tile_pos = 18 - tile_pos;
		} else {
			tile_pos = 30;
		}
	} else if (trob.room == room_AL && tile_pos == 29) {
		tile_pos = -1;
	} else {
		tile_pos = 30;
	}
	return tile_pos;
}

// seg007:032C
short __pascal far get_trob_right_above_pos_in_drawn_room() {
	word tile_pos;
	tile_pos = trob.tile;
	if (trob.room == drawn_room) {
		if (tile_pos % 10 != 9) {
			if (tile_pos < 10) {
				// 0..8 -> -2..-10
				tile_pos = -(tile_pos + 2);
			} else {
				tile_pos -= 9;
			}
		} else {
			tile_pos = 30;
		}
	} else if (trob.room == room_L) {
		if (tile_pos == 9) {
			tile_pos = -1;
		} else {
			if (tile_pos % 10 == 9) {
				tile_pos -= 19;
			} else {
				tile_pos = 30;
			}
		}
	} else if (trob.room == room_B) {
		if (tile_pos < 9) {
			tile_pos += 21;
		} else {
			tile_pos = 30;
		}
	} else if (trob.room == room_BL && tile_pos == 9) {
		tile_pos = 20;
	} else {
		tile_pos = 30;
	}
	return tile_pos;
}

// seg007:03CF
void __pascal far animate_torch() {
	if (is_trob_in_drawn_room()) {
		curr_modifier = get_torch_frame(curr_modifier);
		set_redraw_anim_right();
	}
}

// seg007:03E9
void __pascal far animate_potion() {
	word type;
	if (trob.type >= 0 && is_trob_in_drawn_room()) {
		type = curr_modifier & 0xE0;
		curr_modifier = bubble_next_frame(curr_modifier & 0x1F) | type;
		set_redraw_anim_curr();
	}
}

// seg007:0425
void __pascal far animate_sword() {
	if (is_trob_in_drawn_room()) {
		--curr_modifier;
		if (curr_modifier == 0) {
			curr_modifier = (prandom(255) & 0x3F) + 0x28;
		}
		set_redraw_anim_curr();
	}
}

// seg007:0448
void __pascal far animate_chomper() {
	word blood;
	word frame;
	if (trob.type >= 0) {
		blood = curr_modifier & 0x80;
		frame = (curr_modifier & 0x7F) + 1;
		if (frame > 15) {
			frame = 1;
		}
		curr_modifier = blood | frame;
		if (frame == 2) {
			play_sound(47); // chomper
		}
		// If either:
		// - kid left this room
		// - kid left this row
		// - kid died but not in this chomper
		// and chomper is past frame 6
		// then stop.
		if ((trob.room != drawn_room || trob.tile / 10 != kid.curr_row ||
			(kid.alive >= 0 && blood == 0)) && (curr_modifier & 0x7F) >= 6
		) {
			trob.type = -1;
		}
	}
	if ((curr_modifier & 0x7F) < 6) {
		redraw_at_trob();
	}
}

// seg007:04D3
void __pascal far animate_spike() {
	if (trob.type >= 0) {
		if (curr_modifier == 0xFF) return;
		if (curr_modifier & 0x80) {
			--curr_modifier;
			if (curr_modifier & 0x7F) return;
			curr_modifier = 6;
		} else {
			++curr_modifier;
			if (curr_modifier == 5) {
				curr_modifier = 0x8F;
			} else if (curr_modifier == 9) {
				curr_modifier = 0;
				trob.type = -1;
			}
		}
	}
	redraw_21h();
}

// data:27B2
const byte gate_close_speeds[] = {0, 0, 0, 20, 40, 60, 80, 100, 120};
// data:27C0
const byte door_delta[] = {-1, 4, 4};
// seg007:0522
void __pascal far animate_door() {
	sbyte anim_type;
	anim_type = trob.type;
	if (anim_type >= 0) {
		if (anim_type >= 3) {
			if (anim_type < 8) {
				++anim_type;
				trob.type = anim_type;
			}
			short new_mod = curr_modifier - gate_close_speeds[anim_type];
			curr_modifier = new_mod;
			//if ((sbyte)curr_modifier < 0) {
			if (new_mod < 0) {
			//if ((curr_modifier -= gate_close_speeds[anim_type]) < 0) {
				curr_modifier = 0;
				trob.type = -1;
				play_sound(6); // gate closing fast
			}
		} else {
			if (curr_modifier != 0xFF) {
				curr_modifier += door_delta[anim_type];
				if (anim_type == 0) {
					if (curr_modifier != 0) {
						if (curr_modifier < 188) {
							if ((curr_modifier & 3) == 3) {
								play_door_sound_if_visible(4); // gate closing
							}
						}
					} else {
						gate_stop();
					}
				} else {
					if (curr_modifier < 188) {
						if ((curr_modifier & 7) == 0) {
							play_sound(5); // gate opening
						}
					} else {
						if (anim_type < 2) {
							curr_modifier = 238;
							trob.type = 0;
							play_sound(7); // gate stop
						} else {
							curr_modifier = 0xFF;
							gate_stop();
						}
					}
				}
			} else {
				gate_stop();
			}
		}
	}
	draw_trob();
}

// seg007:05E3
void __pascal far gate_stop() {
	trob.type = -1;
	play_door_sound_if_visible(7); // gate stop
}

// data:27B8
const byte leveldoor_close_speeds[] = {0, 5, 17, 99, 0};
// seg007:05F1
void __pascal far animate_leveldoor() {
	word trob_type;
	trob_type = trob.type;
	if (trob.type >= 0) {
		if (trob_type >= 3) {
			++trob.type;
			curr_modifier -= leveldoor_close_speeds[trob.type - 3];
			if ((sbyte)curr_modifier < 0) {
				curr_modifier = 0;
				trob.type = -1;
				play_sound(14); // level door closing
			} else {
				if (trob.type == 4 &&
					!(sound_flags & sfDigi) &&
					word_1AD80 == 0
				) {
					sound_table_3[15] = 1;
					play_sound(15); // level door opening
				}
			}
		} else {
			++curr_modifier;
			if (curr_modifier >= 43) {
				if (leveldoor_open == 0 || leveldoor_open == 2) {
					trob.type = -1;
					stop_sounds();
					leveldoor_open = 1;
					if (current_level == 4) {
						// Special event: place mirror
						get_tile(4, 4, 0);
						curr_room_tiles[curr_tile_pos] = tiles_13_mirror;
					}
				}
			} else {
				sound_table_3[15] = 0;
				play_sound(15); // level door opening
			}
		}
	}
	set_redraw_anim_right();
}

// seg007:06AD
short __pascal far bubble_next_frame(short curr) {
	short next;
	next = curr + 1;
	if (next >= 8) next = 1;
	return next;
}

// seg007:06CD
short __pascal far get_torch_frame(short curr) {
	short next;
	next = prandom(255);
	if (next != curr) {
		if (next < 9) {
			return next;
		} else {
			next = curr;
		}
	}
	++next;
	if (next >= 9) next = 0;
	return next;
}

// seg007:070A
void __pascal far set_redraw_anim(short tile_pos,char frames) {
	if (tile_pos < 30) {
		if (tile_pos < 0) {
			++tile_pos;
			redraw_frames_above[-tile_pos] = frames;
			// or simply: ~tile_pos
		} else {
			redraw_frames_anim[tile_pos] = frames;
		}
	}
}

// seg007:0738
void __pascal far set_redraw2(short tile_pos,char frames) {
	if (tile_pos < 30) {
		if (tile_pos < 0) {
			++tile_pos;
			redraw_frames_above[-tile_pos] = frames;
			// or simply: ~tile_pos
		} else {
			redraw_frames2[tile_pos] = frames;
		}
	}
}

// seg007:0766
void __pascal far set_redraw_floor_overlay(short tile_pos,char frames) {
	if (tile_pos < 30) {
		if (tile_pos < 0) {
			++tile_pos;
			redraw_frames_above[-tile_pos] = frames;
			// or simply: ~tile_pos
		} else {
			redraw_frames_floor_overlay[tile_pos] = frames;
		}
	}
}

// seg007:0794
void __pascal far set_redraw_full(short tile_pos,char frames) {
	if (tile_pos < 30) {
		if (tile_pos < 0) {
			++tile_pos;
			redraw_frames_above[-tile_pos] = frames;
			// or simply: ~tile_pos
		} else {
			redraw_frames_full[tile_pos] = frames;
		}
	}
}

// seg007:07C2
void __pascal far set_redraw_fore(short tile_pos,char frames) {
	if (tile_pos < 30 && tile_pos >= 0) {
		redraw_frames_fore[tile_pos] = frames;
	}
}

// seg007:07DF
void __pascal far set_wipe(short tile_pos,char frames) {
	if (tile_pos < 30 && tile_pos >= 0) {
		if (wipe_frames[tile_pos] != 0) {
			redraw_height = MAX(wipe_heights[tile_pos], redraw_height);
		}
		wipe_heights[tile_pos] = redraw_height;
		wipe_frames[tile_pos] = frames;
	}
}

// seg007:081E
void __pascal far start_anim_torch(short room,short tile) {
	curr_room_modif[tile] = prandom(8);
	add_trob(room, tile, 1);
}

// seg007:0847
void __pascal far start_anim_potion(short room,short tile) {
	curr_room_modif[tile] &= 0xE0;
	curr_room_modif[tile] |= prandom(6) + 1;
	add_trob(room, tile, 1);
}

// seg007:087C
void __pascal far start_anim_sword(short room,short tile) {
	curr_room_modif[tile] = prandom(0xFF) & 0x1F;
	add_trob(room, tile, 1);
}

// seg007:08A7
void __pascal far start_anim_chomper(short room,short tile,char modifier) {
	short old_modifier;
	old_modifier = curr_room_modif[tile];
	if (old_modifier == 0 || old_modifier >= 6) {
		curr_room_modif[tile] = modifier;
		add_trob(room, tile, 1);
	}
}

// seg007:08E3
void __pascal far start_anim_spike(short room,short tile) {
	sbyte old_modifier;
	old_modifier = curr_room_modif[tile];
	if (old_modifier <= 0) {
		if (old_modifier == 0) {
			add_trob(room, tile, 1);
			play_sound(49); // spikes
		} else {
			if (old_modifier != (sbyte)0xFF) {
				curr_room_modif[tile] = 0x8F;
			}
		}
	}
}

// seg007:092C
short __pascal far trigger_gate(short room,short tile,short button_type) {
	byte modifier;
	modifier = curr_room_modif[tile];
	if (button_type == tiles_15_opener) {
		if (modifier == 0xFF) return -1;
		if (modifier >= 188) { // if it's already open
			curr_room_modif[tile] = 238; // keep it open for a while
			return -1;
		}
		curr_room_modif[tile] = (modifier + 3) & 0xFC;
		return 1; // regular open
	} else if (button_type == tiles_14_debris) {
		if (modifier < 188) return 2; // permanent open
		curr_room_modif[tile] = 0xFF;
		return -1;
	} else {
		if (modifier != 0) {
			return 3; // close
		} else {
			// already closed
			return -1;
		}
	}
}

// seg007:0999
short __pascal far trigger_1(short target_type,short room,short tile,short button_type) {
	short result;
	result = -1;
	if (target_type == tiles_4_gate) {
		result = trigger_gate(room, tile, button_type);
	} else if (target_type == tiles_16_level_door_left) {
		if (curr_room_modif[tile] != 0) {
			result = -1;
		} else {
			result = 1;
		}
	}
	return result;
}

// seg007:09E5
void __pascal far do_trigger_list(short index,short button_type) {
	word room;
	word tile;
	byte target_type;
	sbyte trigger_result;
	while (doorlink1_ad[index] != -1) { // these can't be equal!
		room = get_doorlink_room(index);
		get_room_address(room);
		tile = get_doorlink_tile(index);
		target_type = curr_room_tiles[tile] & 0x1F;
		trigger_result = trigger_1(target_type, room, tile, button_type);
		if (trigger_result >= 0) {
			add_trob(room, tile, trigger_result);
		}
		if (get_doorlink_next(index++) == 0) break;
	}
}

// seg007:0A5A
void __pascal far add_trob(char room,char tile,char type) {
	short found;
	if (trobs_count >= 30) {
		show_dialog("Trobs Overflow");
	}
	trob.room = room;
	trob.tile = tile;
	trob.type = type;
	found = find_trob();
	if (found == -1) {
		// add new
		if (trobs_count == 30) return;
		trobs[trobs_count++] = trob;
	} else {
		// change existing
		trobs[found].type = trob.type;
	}
}

// seg007:0ACA
short __pascal far find_trob() {
	short index;
	for (index = 0; index < trobs_count; ++index) {
		if (trobs[index].tile == trob.tile &&
			trobs[index].room == trob.room) return index;
	}
	return -1;
}

// seg007:0B0A
void __pascal far clear_tile_wipes() {
	memset_near(redraw_frames_full, 0, sizeof(redraw_frames_full));
	memset_near(wipe_frames, 0, sizeof(wipe_frames));
	memset_near(wipe_heights, 0, sizeof(wipe_heights));
	memset_near(redraw_frames_anim, 0, sizeof(redraw_frames_anim));
	memset_near(redraw_frames_fore, 0, sizeof(redraw_frames_fore));
	memset_near(redraw_frames2, 0, sizeof(redraw_frames2));
	memset_near(redraw_frames_floor_overlay, 0, sizeof(redraw_frames_floor_overlay));
	memset_near(tile_object_redraw, 0, sizeof(tile_object_redraw));
	memset_near(redraw_frames_above, 0, sizeof(redraw_frames_above));
}

// seg007:0BB6
short __pascal far get_doorlink_timer(short index) {
	return doorlink2_ad[index] & 0x1F;
}

// seg007:0BCD
short __pascal far set_doorlink_timer(short index,char value) {
	doorlink2_ad[index] &= 0xE0;
	doorlink2_ad[index] |= value & 0x1F;
	return doorlink2_ad[index];
}

// seg007:0BF2
short __pascal far get_doorlink_tile(short index) {
	return doorlink1_ad[index] & 0x1F;
}

// seg007:0C09
short __pascal far get_doorlink_next(short index) {
	return !(doorlink1_ad[index] & 0x80);
}

// seg007:0C26
short __pascal far get_doorlink_room(short index) {
	return
		((doorlink1_ad[index] & 0x60) >> 5) +
		((doorlink2_ad[index] & 0xE0) >> 3);
}

// seg007:0C53
void __pascal far trigger(int playsound,int tile,int modifier) {
	sbyte link_timer;
	get_curr_tile(curr_tile_pos);
	if (tile == 0) {
		// 0 means currently selected
		tile = curr_tile;
	}
	if (modifier == -1) {
		// -1 means currently selected
		modifier = curr_modifier;
	}
	link_timer = get_doorlink_timer(modifier);
	// is the event jammed?
	if (link_timer != 0x1F) {
		set_doorlink_timer(modifier, 5);
		if (link_timer < 2) {
			add_trob(curr_room, curr_tile_pos, 1);
			redraw_11h();
			is_guard_notice = 1;
			if (playsound) {
				play_sound(3); // button pressed
			}
		}
		do_trigger_list(modifier, tile);
	}
}

// seg007:0CD9
void __pascal far died_on_button() {
	word tile;
	word modifier;
	tile = get_curr_tile(curr_tile_pos);
	modifier = curr_modifier;
	if (curr_tile == tiles_15_opener) {
		curr_room_tiles[curr_tile_pos] = tiles_1_floor;
		curr_room_modif[curr_tile_pos] = 0;
		tile = tiles_14_debris; // force permsnent open
	} else {
		curr_room_tiles[curr_tile_pos] = tiles_5_stuck;
	}
	trigger(1, tile, modifier);
}

// seg007:0D3A
void __pascal far animate_button() {
	word var_2;
	if (trob.type >= 0) {
		set_doorlink_timer(curr_modifier, var_2 = get_doorlink_timer(curr_modifier) - 1);
		if (var_2 < 2) {
			trob.type = -1;
			redraw_11h();
		}
	}
}

// seg007:0D72
void __pascal far start_level_door(short room,short tile) {
	curr_room_modif[tile] = 43; // start fully open
	add_trob(room, tile, 3);
}

// seg007:0D93
void __pascal far animate_empty() {
	trob.type = -1;
	redraw_20h();
}

// data:2284
const word y_loose_land[] = {2, 65, 128, 191, 254};
// seg007:0D9D
void __pascal far animate_loose() {
	word room;
	word row;
	word tile;
	short type;
	type = trob.type;
	if (type >= 0) {
		++curr_modifier;
		if (curr_modifier & 0x80) {
			// just shaking
			// don't shake on level 13
			if (current_level == 13) return;
			if (curr_modifier >= 0x84) {
				curr_modifier = 0;
				trob.type = -1;
			}
			loose_shake(!curr_modifier);
		} else {
			// something is on the floor
			// should it fall already?
			if (curr_modifier >= 11) {
				curr_modifier = remove_loose(room = trob.room, tile = trob.tile);
				trob.type = -1;
				curmob.xh = (tile % 10) << 2;
				row = tile / 10;
				curmob.y = y_loose_land[row + 1];
				curmob.room = room;
				curmob.speed = 0;
				curmob.type = 0;
				curmob.row = row;
				add_mob();
			} else {
				loose_shake(0);
			}
		}
	}
	redraw_20h();
}

// data:2734
const byte loose_sound[] = {0, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0};
// data:5F84
word last_loose_sound;
// seg007:0E55
void __pascal far loose_shake(int arg_0) {
	word sound_id;
	if (arg_0 || loose_sound[curr_modifier & 0x7F]) {
		do {
			sound_id = prandom(2) + 20;
		} while(sound_id == last_loose_sound);
		if (sound_flags & sfDigi) {
			last_loose_sound = sound_id;
			// random sample rate (10500..11500)
			//sound_pointers[sound_id]->samplerate = prandom(1000) + 10500;
		}
		play_sound(sound_id);
	}
}

// seg007:0EB8
int __pascal far remove_loose(int room, int tilepos) {
	curr_room_tiles[tilepos] = tiles_0_empty;
	// note: the level type is used to determine the modifier of the empty space left behind
	return tbl_level_type[current_level];
}

// seg007:0ED5
void __pascal far make_loose_fall(char modifier) {
	// is it a "solid" loose floor?
	if ((curr_room_tiles[curr_tile_pos] & 0x20) == 0) {
		if (curr_room_modif[curr_tile_pos] <= 0) {
			curr_room_modif[curr_tile_pos] = modifier;
			add_trob(curr_room, curr_tile_pos, 0);
			redraw_20h();
		}
	}
}

// seg007:0F13
void __pascal far start_chompers() {
	short timing;
	short modifier;
	short tile;
	short column;
	timing = 15;
	if ((byte)char_.curr_row < 3) {
		get_room_address(char_.room);
		for (column = 0, tile = tbl_line[char_.curr_row];
			column < 10; ++column, ++tile
		){
			if (get_curr_tile(tile) == tiles_18_chomper) {
				modifier = curr_modifier & 0x7F;
				if (modifier == 0 || modifier >= 6) {
					start_anim_chomper(char_.room, tile, timing | (curr_modifier & 0x80));
					timing = next_chomper_timing(timing);
				}
			}
		}
	}
}

// seg007:0F9A
int __pascal far next_chomper_timing(byte timing) {
	// 15,12,9,6,13,10,7,14,11,8,repeat
	timing -= 3;
	if (timing < 6) {
		timing += 10;
	}
	return timing;
}

// seg007:0FB4
void __pascal far loose_make_shake() {
	if (curr_room_modif[curr_tile_pos] == 0 && current_level != 13) {
		curr_room_modif[curr_tile_pos] = 0x80;
		add_trob(curr_room, curr_tile_pos, 1);
	}
}

// seg007:0FE0
void __pascal far do_knock(int room,int tile_row) {
	short tile_col;
	for (tile_col = 0; tile_col < 10; ++tile_col) {
		if (get_tile(room, tile_col, tile_row) == tiles_11_loose) {
			loose_make_shake();
		}
	}
}

// seg007:1010
void __pascal far add_mob() {
	if (mobs_count >= 14) {
		show_dialog("Mobs Overflow");
	}
	mobs[mobs_count++] = curmob;
}

// seg007:1041
short __pascal far get_curr_tile(short tilepos) {
	curr_modifier = curr_room_modif[tilepos];
	return curr_tile = curr_room_tiles[tilepos] & 0x1F; 
}

// data:43DC
word curmob_index;

// seg007:1063
void __pascal far do_mobs() {
	short n_mobs;
	short index;
	short new_index;
	n_mobs = mobs_count;
	for (curmob_index = 0; n_mobs > curmob_index; ++curmob_index) {
		curmob = mobs[curmob_index];
		do_mob();
		check_loose_fall_on_kid();
		mobs[curmob_index] = curmob;
	}
	new_index = 0;
	for (index = 0; index < mobs_count; ++index) {
		if (mobs[index].speed != -1) {
			mobs[new_index++] = mobs[index];
		}
	}
	mobs_count = new_index;
}

// seg007:110F
void __pascal far do_mob() {
	if (curmob.type == 0) {
		do_loose();
	}
	if (curmob.speed <= 0) {
		++curmob.speed;
	}
}

// data:227A
const short y_something[] = {-1, 62, 125, 188, 25};
// data:594A
word curr_tile_temp;
// seg007:1126
void __pascal far do_loose() {
	if (curmob.speed < 0) return;
	if (curmob.speed < 29) curmob.speed += 3;
	curmob.y += curmob.speed;
	if (curmob.room == 0) {
		if (curmob.y < 210) {
			return;
		} else {
			curmob.speed = -2;
			return;
		}
	}
	if (curmob.y < 226 && y_something[curmob.row + 1] <= curmob.y) {
		// fell into a different row
		curr_tile_temp = get_tile(curmob.room, curmob.xh >> 2, curmob.row);
		if (curr_tile_temp == tiles_11_loose) {
			loose_fall();
		}
		if (curr_tile_temp == tiles_0_empty ||
			curr_tile_temp == tiles_11_loose
		) {
			mob_down_a_row();
			return;
		}
		play_sound(2); // tile crashing
		do_knock(curmob.room, curmob.row);
		curmob.y = y_something[curmob.row + 1];
		curmob.speed = -2;
		loose_land();
	}
}

// seg007:11E8
void __pascal far loose_land() {
	short currtile;
	short tile;
	currtile = 0;
	tile = get_tile(curmob.room, curmob.xh >> 2, curmob.row);
	switch (tile) {
		case tiles_15_opener:
			curr_room_tiles[curr_tile_pos] = tiles_14_debris;
			currtile = tiles_14_debris;
		// fallthrough!
		case tiles_6_closer:
			trigger(1, currtile, -1);
			tile = get_tile(curmob.room, curmob.xh >> 2, curmob.row);
		// fallthrough!
		case tiles_1_floor:
		case tiles_2_spike:
		case tiles_10_potion:
		case tiles_19_torch:
		case tiles_30_torch_with_debris:
			if (tile == tiles_19_torch ||
				tile == tiles_30_torch_with_debris
			) {
				curr_room_tiles[curr_tile_pos] = tiles_30_torch_with_debris;
			} else {
				curr_room_tiles[curr_tile_pos] = tiles_14_debris;
			}
			draw_cur_mob();
			if (tile_col != 0) {
				set_redraw_full(curr_tile_pos - 1, 1);
			}
	}
}

// seg007:12CB
void __pascal far loose_fall() {
	curr_room_modif[curr_tile_pos] = remove_loose(curr_room, curr_tile_pos);
	curmob.speed >>= 1;
	mobs[curmob_index] = curmob;
	curmob.y += 6;
	mob_down_a_row();
	add_mob();
	curmob = mobs[curmob_index];
	draw_cur_mob();
}

// seg007:132C
void __pascal far draw_cur_mob() {
	if (curmob.room == drawn_room) {
		redraw_height = 0x20;
		set_redraw_full(curr_tile_pos, 1);
		set_wipe(curr_tile_pos, 1);
		if ((curr_tile_pos + 1) % 10 < 10) {
			set_redraw_full(curr_tile_pos + 1, 1);
			set_wipe(curr_tile_pos + 1, 1);
		}
	}
}

// seg007:1387
void __pascal far mob_down_a_row() {
	++curmob.row;
	if (curmob.row >= 3) {
		curmob.y -= 192;
		curmob.row = 0;
		curmob.room = level.roomlinks[curmob.room - 1].down;
	}
}

// seg007:13AE
void __pascal far draw_mobs() {
	short index;
	for (index = 0; index < mobs_count; ++index) {
		curmob = mobs[index];
		draw_mob();
	}
}

// seg007:13E5
void __pascal far draw_mob() {
	short tile_row;
	short ypos;
	short top_row;
	short tile_pos;
	short tile_col;
	ypos = curmob.y;
	if (curmob.room == drawn_room ) {
		if (curmob.y >= 210) return;
	} else if (curmob.room == room_B) {
		if (ABS(ypos) >= 18) return;
		curmob.y += 192;
		ypos = curmob.y;
	} else if (curmob.room != room_A) {
		return;
	} else if (curmob.y < 174) {
		return;
	} else {
		ypos = curmob.y - 189;
	}
	tile_col = curmob.xh >> 2;
	tile_row = y_to_row_mod4(ypos);
	obj_tile = get_tile_pos_nominus(tile_col, tile_row);
	++tile_col;
	tile_pos = get_tile_pos(tile_col, tile_row);
	set_redraw2(tile_pos, 1);
	set_redraw_fore(tile_pos, 1);
	top_row = y_to_row_mod4(ypos - 18);
	if (top_row != tile_row) {
		tile_pos = get_tile_pos(tile_col, top_row);
		set_redraw2(tile_pos, 1);
		set_redraw_fore(tile_pos, 1);
	}
	add_mob_to_objtable(ypos);
}

// seg007:14DE
void __pascal far add_mob_to_objtable(int ypos) {
	word index;
	objtable_type* curr_obj;
	index = objtable_count++;
	curr_obj = &objtable[index];
	curr_obj->obj_type = curmob.type | 0x80;
	curr_obj->xh = curmob.xh;
	curr_obj->xl = 0;
	curr_obj->y = ypos;
	curr_obj->chtab_id = id_chtab_6_environment;
	curr_obj->id = 10;
	curr_obj->clip.top = 0;
	curr_obj->clip.left = 0;
	curr_obj->clip.right = 40;
	mark_obj_tile_redraw(index);
}

// seg007:153E
void __pascal far sub_9A8E() {
	// This function is not used.
	method_1_blit_rect(onscreen_surface_, offscreen_surface, &rect_top, &rect_top, 0);
}

// seg007:1556
int __pascal far is_spike_harmful() {
	sbyte modifier;
	modifier = curr_room_modif[curr_tile_pos];
	if (modifier == 0 || modifier == -1) {
		return 0;
	} else if (modifier < 0) {
		return 1;
	} else if (modifier < 5) {
		return 2;
	} else {
		return 0;
	}
}

// seg007:1591
void __pascal far check_loose_fall_on_kid() {
	loadkid();
	if (char_.room == curmob.room &&
		char_.curr_col == curmob.xh >> 2 &&
		curmob.y < char_.y &&
		char_.y - 30 < curmob.y
	) {
		fell_on_your_head();
		savekid();
	}
}

// seg007:15D3
void __pascal far fell_on_your_head() {
	short frame;
	short action;
	frame = char_.frame;
	action = char_.action;
	// loose floors hurt you in frames 5..14 (running) only on level 13
	if (
		(current_level == 13 || (frame < 5 || frame >= 15)) &&
		(action < actions_2_hang_climb || action == actions_7_turn)
	) {
		char_.y = y_land[char_.curr_row + 1];
		if (take_hp(1)) {
			seqtbl_offset_char(22); // dead
			if (frame == 177) { // spiked
				char_.x = char_dx_forward(-12);
			}
		} else {
			if (frame != 109) { // crouching
				if (get_tile_behind_char() == 0) {
					char_.x = char_dx_forward(-2);
				}
				seqtbl_offset_char(52); // hard land
			}
		}
	}
}

// seg007:1669
void __pascal far play_door_sound_if_visible(int sound_id) {
	word has_sound;
	word tile_pos;
	word gate_room;
	tile_pos = trob.tile;
	gate_room = trob.room;
	has_sound = 0;
	// Special event: sound of closing gates
	if ((current_level == 3 && gate_room == 2) || (
#ifdef FIX_GATE_SOUNDS
		(gate_room == room_L && tile_pos % 10 == 9) ||
#else
		gate_room == room_L ? tile_pos % 10 == 9 :
#endif
		(gate_room == drawn_room && tile_pos % 10 != 9))
	) {
		has_sound = 1;
	}
	if (has_sound) {
		play_sound(sound_id);
	}
}
