//#include "seg009.h"
#include "common.h"
#include <fcntl.h>
#include <stdlib.h>

// Most functions in this file are different from those in the original game.

void sdlperror(const char* header) {
	const char* error = SDL_GetError();
	printf("%s: %s\n",header,error);
	//exit(1);
}

dat_type* dat_chain_ptr;

int last_key;

// seg009:000D
int __pascal far read_key() {
	// stub
	int key = last_key;
	last_key = 0;
	return key;
}

// seg009:019A
void __pascal far clear_kbd_buf() {
	// stub
	last_key = 0;
}

// seg009:040A
word __pascal far prandom(word max) {
	if (!seed_was_init) {
		// should init from current time
		// get_time?(&random_seed, 0);
		seed_was_init = 1;
	}
	random_seed = random_seed * 214013 + 2531011;
	return (random_seed >> 16) % (max + 1);
}

// seg009:0467
int __pascal far round_xpos_to_byte(int xpos,int round_direction) {
	// stub
	return xpos;
}

// seg009:0C7A
void __pascal far quit(int exit_code) {
	restore_stuff();
	exit(exit_code);
}

// seg009:0C90
void __pascal far restore_stuff() {
	SDL_Quit();
}

// seg009:0E33
int __pascal far key_test_quit() {
	word key;
	key = read_key();
	if (key == 0x11) { // ctrl-q
		quit(0);
	}
	return key;
}

// seg009:0E54
char* __pascal far check_param(const char *param) {
	// stub
	short arg_index;
	for (arg_index = 1; arg_index < g_argc; ++arg_index) {
		if (/*strnicmp*/strncasecmp(g_argv[arg_index], param, strlen(param)) == 0) {
			return g_argv[arg_index];
		}
	}
	return 0;
}

// seg009:0EDF
int __pascal far wait(int timer_index,int time) {
	//wait_time[timer_index] = time;
	start_timer(timer_index, time);
	return do_wait(timer_index);
}

// seg009:0F58
dat_type *__pascal load_dat_to_handle(const char *file,int drive) {
	dat_type* pointer = malloc(sizeof(dat_type));
	memset(pointer, 0, sizeof(dat_type));
	strncpy(pointer->filename, file, sizeof(pointer->filename));
	pointer->next_dat = dat_chain_ptr;
	dat_chain_ptr = pointer;
	// stub
	return pointer;
}

// seg009:101B
//int __pascal far file_exists(const char near *filename) ;

// seg009:A172
//int __pascal far load_from_opendats_to_area(int resource,void far *area,int length) {
//}

// seg009:9CAC
void __pascal far set_loaded_palette(dat_pal_type far *palette_ptr) {
	int si, di, current_row;
	for (si = di = current_row = 0; si < 16; ++si, di += 0x10) {
		if (palette_ptr->row_bits & (1 << si)) {
			set_pal_arr(di, 16, palette_ptr->vga + current_row*0x10, 1);
			++current_row;
		}
	}
}

// data:3356
word chtab_palette_bits = 1;

// seg009:104E
chtab_type* __pascal load_sprites_from_file(int resource,int palette_bits,byte* pack,int shift) {
#if 0
	chtab_type* chtab_ptr;
	dat_shpl_type area;
	word curr_image_index;
	dat_pal_type* pal_ptr;
	word count;
	void* xlat_buffer;
	word var_2;
	has_palette_bits = 1;
	load_from_opendats_to_area(resource, &area, 0);
	pal_ptr = &area.palette;
	if (graphics_mode == gmMcgaVga) {
		if (palette_bits == 0) {
			palette_bits = add_palette_bits(area1_ptr->n_colors);
			if (palette_bits == 0) {
				quit(1);
			}
		} else {
			chtab_palette_bits |= palette_bits;
			has_palette_bits = 0;
		}
		area1_ptr->row_bits = palette_bits;
	}
	count = area.n_images;
	if (graphics_mode != gmCga && graphics_mode != gmHgaHerc) {
		shift = 0;
	}
	count <<= shift;
	chtab_ptr = malloc_near(sizeof(chtab_type) + count * sizeof(image_type* far));
	xlat_buffer = malloc_near(0x200);
	process_palette(xlat_buffer, area1_ptr);
	if (graphics_mode == gmMcgaVga) {
		chtab_ptr->chtab_palette_bits = palette_bits;
		chtab_ptr->has_palette_bits = has_palette_bits;
	}
	chtab_ptr->n_images = count;
	for (curr_image_index = 0; curr_image_index < area.n_images; ++curr_image_index) {
		chtab_ptr->pointers[curr_image_index] = load_image(
			resource + curr_image_index + 1, xlat_buffer, shift,
			chtab_ptr->pointers[curr_image_index + area.n_images],
			(int)pack == -1 ? 1 : (int)pack == 0 ? 0 : pack[curr_image_index]
		);
	}
	set_loaded_palette(area1_ptr);
	free_near(xlat_buffer);
	return chtab_ptr;
#endif // 0

	char image_filename[256];
	int i;
	dat_shpl_type area;
	dat_pal_type* pal_ptr;
	int n_images = 0;
	chtab_type* chtab;
	int fd = -1;
	dat_type* pointer;
	int has_palette_bits = 1;
	for (pointer = dat_chain_ptr; fd == -1 && pointer != NULL; pointer = pointer->next_dat) {
		snprintf(image_filename,sizeof(image_filename),"data/%s/res%d.pal",pointer->filename,resource);
		printf("loading (palette) %s",image_filename);
		fd = open(image_filename, O_RDONLY);
	}
	printf("\n");
	if (fd == -1) {
		printf(" FAILED\n");
		return NULL;
	}
	read(fd, &area, sizeof(area));
	close(fd);
	
	pal_ptr = &area.palette;
	if (graphics_mode == gmMcgaVga) {
		if (palette_bits == 0) {
			/*
			palette_bits = add_palette_bits(pal_ptr->n_colors);
			if (palette_bits == 0) {
				quit(1);
			}
			*/
		} else {
			chtab_palette_bits |= palette_bits;
			has_palette_bits = 0;
		}
		pal_ptr->row_bits = palette_bits;
	}
	
	n_images = area.n_images;
	size_t alloc_size = sizeof(chtab_type) + sizeof(void far *) * n_images;
	chtab = malloc(alloc_size);
	memset(chtab, 0, alloc_size);
	chtab->n_images = n_images;
	for (i = 1; i <= n_images; i++) {
		SDL_Surface* image = NULL;
		for (pointer = dat_chain_ptr; image == NULL && pointer != NULL; pointer = pointer->next_dat) {
			snprintf(image_filename,sizeof(image_filename),"data/%s/res%d.png",pointer->filename,resource+i);
			printf("loading (%3d) %s",i,image_filename);
			image = IMG_Load(image_filename);
		}
		if (image == NULL) printf(" failed");
		if (image != NULL) {
			if (SDL_SetAlpha(image, 0, 0) != 0) {
				sdlperror("SDL_SetAlpha");
				exit(1);
			}
			if (SDL_SetColorKey(image, SDL_SRCCOLORKEY, 0) != 0) {
				sdlperror("SDL_SetColorKey");
				exit(1);
			}
		}
		printf("\n");
		chtab->pointers[i-1] = image;
	}
	set_loaded_palette(pal_ptr);
	return chtab;
}

// seg009:11A8
void __pascal far free_chtab(chtab_type *chtab_ptr) {
	image_type far* curr_image;
	word id;
	word n_images;
	if (graphics_mode == gmMcgaVga && chtab_ptr->has_palette_bits) {
		chtab_palette_bits &= ~ chtab_ptr->chtab_palette_bits;
	}
	n_images = chtab_ptr->n_images;
	for (id = 0; id < n_images; ++id) {
		curr_image = chtab_ptr->pointers[id];
		if (curr_image) {
			/*free_far*/SDL_FreeSurface(curr_image);
		}
	}
	free_near(chtab_ptr);
}

// seg009:121A
image_type*far __pascal far load_image(int index,void* xlat_tbl,int use_global_xlat,void* target,int pack) {
	// stub
	return NULL;
}

// seg009:13C4
void __pascal far draw_image_transp(image_type far *image,image_type far *mask,int xpos,int ypos) {
	if (graphics_mode == gmMcgaVga) {
		draw_image_transp_vga(image, xpos, ypos);
	} else {
		// ...
	}
}

// seg009:157E
int __pascal far set_joy_mode() {
	// stub
	is_joyst_mode = 0;
	is_keyboard_mode = !is_joyst_mode;
	return 0;
}

// seg009:178B
surface_type far *__pascal make_offscreen_buffer(const rect_type far *rect) {
	// stub
#ifndef USE_ALPHA
	//return SDL_CreateRGBSurface(0, rect->right, rect->bottom, 24, 0xFF, 0xFF<<8, 0xFF<<16, 0);
	// Bit order matches onscreen buffer, good for fading.
	return SDL_CreateRGBSurface(0, rect->right, rect->bottom, 24, 0xFF<<16, 0xFF<<8, 0xFF<<0, 0);
#else
	return SDL_CreateRGBSurface(0, rect->right, rect->bottom, 32, 0xFF, 0xFF<<8, 0xFF<<16, 0xFF<<24);
#endif
	//return surface;
}

// seg009:17BD
void __pascal far free_surface(surface_type *surface) {
	SDL_FreeSurface(surface);
}

// seg009:17EA
void __pascal far free_peel(peel_type *peel_ptr) {
	//method_8_free(peel_ptr->peel);
	SDL_FreeSurface(peel_ptr->peel);
	//free_near(peel_ptr);
}

const rgb_type vga_palette[] = {
{0x00, 0x00, 0x00},
{0x00, 0x00, 0x2A},
{0x00, 0x2A, 0x00},
{0x00, 0x2A, 0x2A},
{0x2A, 0x00, 0x00},
{0x2A, 0x00, 0x2A},
{0x2A, 0x15, 0x00},
{0x2A, 0x2A, 0x2A},
{0x15, 0x15, 0x15},
{0x15, 0x15, 0x3F},
{0x15, 0x3F, 0x15},
{0x15, 0x3F, 0x3F},
{0x3F, 0x15, 0x15},
{0x3F, 0x15, 0x3F},
{0x3F, 0x3F, 0x15},
{0x3F, 0x3F, 0x3F},
};

// seg009:182F
void __pascal far set_hc_pal() {
	// stub
	if (graphics_mode == gmMcgaVga) {
		set_pal_arr(0, 16, vga_palette, 1);
	} else {
		// ...
	}
}

// seg009:2446
void __pascal far flip_not_ega(byte far *memory,int bottom,int stride) {
	byte* row_buffer = malloc(stride);
	byte* top_ptr;
	byte* bottom_ptr;
	short cx = bottom;
	bottom_ptr = top_ptr = memory;
	bottom_ptr += (bottom - 1) * stride;
	cx = bottom >> 1;
	do {
		memcpy(row_buffer, top_ptr, stride);
		memcpy(top_ptr, bottom_ptr, stride);
		memcpy(bottom_ptr, row_buffer, stride);
		top_ptr += stride;
		bottom_ptr -= stride;
		--cx;
	} while (cx);
	free(row_buffer);
}

// seg009:19B1
void __pascal far flip_screen(surface_type far *surface) {
	// stub
	if (graphics_mode != gmEga) {
		if (SDL_LockSurface(surface) != 0) {
			sdlperror("SDL_LockSurface");
			quit(1);
		}
		flip_not_ega(surface->pixels, surface->h, surface->pitch);
		SDL_UnlockSurface(surface);
	} else {
		// ...
	}
}

#ifndef USE_FADE
// seg009:19EF
void __pascal far fade_in_2(surface_type near *source_surface,int which_rows) {
	// stub
	method_1_blit_rect(onscreen_surface_, source_surface, &screen_rect, &screen_rect, 0);
	SDL_UpdateRect(onscreen_surface_, 0, 0, 0, 0); // debug
}

// seg009:1CC9
void __pascal far fade_out_2(int rows) {
	// stub
}
#endif // USE_FADE

// seg009:2288
void __pascal far draw_image_transp_vga(image_type far *image,int xpos,int ypos) {
	// stub
	method_6_blit_img_to_scr(image, xpos, ypos, 0x10);
}

#ifdef USE_TEXT

font_type hc_font = {0x01,0xFF, 7,2,1,1, NULL};
textstate_type textstate = {0,0,0,15,&hc_font};

void load_font() {
	dat_type* dathandle = load_dat_to_handle("font", 0);
	hc_font.chtab = load_sprites_from_file(1000, 1<<1, 0, 0);
	release_dathandle(dathandle);
}

// seg009:35C5
int __pascal far get_char_width(byte character) {
	font_type* font = textstate.ptr_font;
	int ax = 0;
	if (character <= font->last_char && character >= font->first_char) {
		ax += font->chtab->pointers[character - font->first_char]->w; //char_ptrs[character - font->first_char]->width;
		if (ax) ax += font->space_between_chars;
	}
	return ax;
}

// seg009:3E99
int __pascal far measure_text_line(const char far *text,int length,int break_width,int x_align) {
	short curr_line_width;
	short curr_line_length;
	int di = 0;
	curr_line_length = 0;
	curr_line_width = 0;
	const char* si = text;
	while (di < length) {
		curr_line_width += get_char_width(*si);
		if (curr_line_width <= break_width) {
			++di;
			char al = *(si++);
			if (al == '\r') {
				return di;
			}
			if (al == '-' ||
				(x_align <= 0 && (al == ' ' || *si == ' ')) ||
				(*si == ' ' && al == ' ')
			) {
				// May break here
				curr_line_length = di;
			}
		} else {
			if (curr_line_length == 0) {
				// If the first word is wider than the rect then break it.
				return di;
			} else {
				// Otherwise break at the last space.
				return curr_line_length;
			}
		}
	}
	return di;
}

// seg009:403F
int __pascal far get_line_width(const char far *text,int length) {
	int di = 0;
	const char* si = text;
	while (--length >= 0) {
		di += get_char_width(*(si++));
	}
	return di;
}

// seg009:3706
int __pascal far draw_text_character(byte character) {
	font_type* font = textstate.ptr_font;
	int ax = 0;
	if (character <= font->last_char && character >= font->first_char) {
		image_type* image = font->chtab->pointers[character - font->first_char]; //char_ptrs[character - font->first_char];
		method_3_blit_mono(image, textstate.current_x, textstate.current_y - font->height_above_baseline, textstate.textblit, textstate.textcolor);
		ax = font->space_between_chars + image->w;
	}
	textstate.current_x += ax;
	return ax;
}

// seg009:377F
int __pascal far draw_text_line(const char far *text,int length) {
	//hide_cursor();
	int di = 0;
	const char* si = text;
	while (--length >= 0) {
		di += draw_text_character(*(si++));
	}
	//show_cursor();
	return di;
}

// seg009:3755
int __pascal far draw_cstring(const char far *string) {
	//hide_cursor();
	int di = 0;
	const char* si = string;
	while (*si) {
		di += draw_text_character(*(si++));
	}
	//show_cursor();
	return di;
}

// seg009:3F01
const rect_type far *__pascal draw_text(const rect_type far *rect_ptr,int x_align_or_break,int y_align,const char far *text_ptr,int length) {
	short rect_top;
	short rect_height;
	short rect_width;
	//textinfo_type var_C;
	short num_lines;
	short font_line_distance;
	//hide_cursor();
	//get_textinfo(&var_C);
	set_clip_rect(rect_ptr);
	rect_width = rect_ptr->right - rect_ptr->left;
	rect_top = rect_ptr->top;
	rect_height = rect_ptr->bottom - rect_ptr->top;
	num_lines = 0;
	int di = length;
	const char* si = text_ptr;
	static const int max_lines = 100;
	const char* line_starts[max_lines];
	int line_lengths[max_lines];
	do {
		int ax = measure_text_line(si, di, rect_width, x_align_or_break);
		if (ax == 0) break;
		if (num_lines >= max_lines) {
			//... ERROR!
			printf("draw_text(): Too many lines!\n");
			quit(1);
		}
		line_starts[num_lines] = si;
		line_lengths[num_lines] = ax;
		++num_lines;
		si += ax;
		di -= ax;
	} while(di);
	font_type* font = textstate.ptr_font;
	font_line_distance = font->height_above_baseline + font->height_below_baseline + font->space_between_lines;
	int text_height = font_line_distance * num_lines - font->space_between_lines;
	int text_top = rect_top;
	if (y_align >= 0) {
		if (y_align <= 0) {
			// middle
			text_top += rect_height/2 - text_height/2;
		} else {
			// bottom
			text_top += rect_height - text_height;
		}
	}
	textstate.current_y = text_top + font->height_above_baseline;
	int i;
	for (i = 0; i < num_lines; ++i) {
		const char* bx = line_starts[i];
		int dx = line_lengths[i];
		if (x_align_or_break < 0 &&
			*bx == ' ' &&
			i != 0 &&
			*(bx-1) != '\r'
		) {
			// Skip over space if it's not at the beginning of a line.
			++bx;
			--dx;
			if (dx != 0 &&
				*bx == ' ' &&
				*(bx-2) == '.'
			) {
				// Skip over second space after point.
				++bx;
				--dx;
			}
		}
		int ax = get_line_width(bx,dx);
		int text_left = rect_ptr->left;
		if (x_align_or_break >= 0) {
			if (x_align_or_break <= 0) {
				// center
				text_left += rect_width/2 - ax/2;
			} else {
				// right
				text_left += rect_width - ax;
			}
		}
		textstate.current_x = text_left;
		draw_text_line(bx,dx);
		textstate.current_y += font_line_distance;
	}
	reset_clip_rect();
	//set_textinfo(...);
	//show_cursor();
	return rect_ptr;
}

// seg009:3E4F
void __pascal far show_text(const rect_type far *rect_ptr,int x_align_or_break,int y_align,const char far *text) {
	// stub
	//printf("show_text: %s\n",text);
	draw_text(rect_ptr, x_align_or_break, y_align, text, strlen(text));
}

// seg009:04FF
void __pascal far show_text_with_color(rect_type far *rect_ptr,int x_align,int y_align,char far *text,int color) {
	short saved_textcolor;
	saved_textcolor = textstate.textcolor;
	textstate.textcolor = color;
	show_text(rect_ptr, x_align, y_align, text);
	textstate.textcolor = saved_textcolor;
}

// seg009:3A91
void __pascal far set_curr_pos(int xpos,int ypos) {
	textstate.current_x = xpos;
	textstate.current_y = ypos;
}

// seg009:0838
int __pascal far showmessage(char far *text,int arg_4,void far *arg_0) {
#if 0
	word key;
	rect_type rect;
	font_type* saved_font_ptr;
	surface_type* old_target;
	old_target = current_target_surface;
	current_target_surface = onscreen_surface_;
	method_1_blit_rect(word_1F942->0x14, onscreen_surface_, &word_1F942->0x0A, &word_1F942->0x0A, 0);
	sub_D16E(word_1F942);
	saved_font_ptr = current_target_surface->ptr_font;
	current_target_surface->ptr_font = ptr_font;
	shrink2_rect(&rect, word_1F942->0x02, 2, 1);
	show_text_with_color(&rect, 0, 0, text, 15);
	current_target_surface->ptr_font = saved_font_ptr;
	clear_kbd_buf();
	do {
		key = key_test_quit();
	} while(key == 0);
	sub_DF99(word_1F942->0x14);
	current_target_surface = old_target;
	return key;
#else // 0
	return 0;
#endif // 0
}

// seg009:0C44
void __pascal far show_dialog(const char *text) {
	char string[256];
	snprintf(string, sizeof(string), "%s\r\rPress any key to continue.", text);
	showmessage(string, 1, &key_test_quit);
}

// seg009:0791
int __pascal far sub_CF21(const rect_type far *rect) {
	const font_type far* font;
	short var_6;
	font = &hc_font;//current_target_surface->ptr_font;
	var_6 = rect->bottom - font->height_above_baseline - font->height_below_baseline - rect->top;
	return ((var_6 - var_6 % 2) >> 1) + font->height_above_baseline + var_6 % 2 + rect->top;
}

// seg009:3E77
int __pascal far get_cstring_width(const char far *text) {
	int di = 0;
	const char* si = text;
	char al;
	while (0 != (al = *(si++))) {
		di += get_char_width(al);
	}
	return di;
}

// seg009:0767
void __pascal far draw_text_cursor(int xpos,int ypos,int color) {
	set_curr_pos(xpos, ypos);
	/*current_target_surface->*/textstate.textcolor = color;
	draw_text_character('_');
	//restore_curr_color();
}

// seg009:053C
int __pascal far input_str(const rect_type far *rect,char *buffer,int max_length,const char *initial,int has_initial,int arg_4,int color,int bgcolor) {
	short length;
	word key;
	short var_6;
	short current_xpos;
	short ypos;
	short init_length;
	length = 0;
	var_6 = 0;
	draw_rect(rect, bgcolor);
	init_length = strlen(initial);
	if (has_initial) {
		strcpy(buffer, initial);
		length = init_length;
	}
	current_xpos = rect->left + arg_4;
	ypos = sub_CF21(rect);
	set_curr_pos(current_xpos, ypos);
	/*current_target_surface->*/textstate.textcolor = color;
	draw_cstring(initial);
	//restore_curr_pos?();
	current_xpos += get_cstring_width(initial) + (init_length != 0) * arg_4;
	do {
		key = 0;
		do {
			if (var_6) {
				draw_text_cursor(current_xpos, ypos, color);
			} else {
				draw_text_cursor(current_xpos, ypos, bgcolor);
			}
			var_6 = !var_6;
			start_timer(0, 6);
			if (key) {
				if (var_6) {
					draw_text_cursor(current_xpos, ypos, color);
					var_6 = !var_6;
				}
				if (key == 0x0D) { // enter
					buffer[length] = 0;
					return length;
				} else break;
			}
//			while (!timer_stopped[0] && (key = key_test_quit()) == 0) idle();
			while (!has_timer_stopped(0) && (key = key_test_quit()) == 0) idle();
		} while (1);
		if (key == 0x1B) { // esc
			draw_rect(rect, bgcolor);
			buffer[0] = 0;
			return -1;
		}
		if (length != 0 && (key == 8 || key == 0x5300)) { // backspace, delete
			--length;
			draw_text_cursor(current_xpos, ypos, bgcolor);
			current_xpos -= get_char_width(buffer[length]);
			set_curr_pos(current_xpos, ypos);
			/*current_target_surface->*/textstate.textcolor = bgcolor;
			draw_text_character(buffer[length]);
			//restore_curr_pos?();
			draw_text_cursor(current_xpos, ypos, color);
		} else if (key >= 0x20 && key <= 0x7E && length < max_length) {
			// Would the new character make the cursor go past the right side of the rect?
			if (get_char_width('_') + get_char_width(key) + current_xpos < rect->right) {
				draw_text_cursor(current_xpos, ypos, bgcolor);
				set_curr_pos(current_xpos, ypos);
				/*current_target_surface->*/textstate.textcolor = color;
				current_xpos += draw_text_character(buffer[length++] = key);
			}
		}
	} while(1);
}

#else // USE_TEXT

// seg009:3706
int __pascal far draw_text_character(byte character) {
	// stub
	printf("draw_text_character: %c\n",character);
	return 0;
}

// seg009:3E4F
void __pascal far show_text(const rect_type far *rect_ptr,int x_align_or_break,int y_align,const char far *text) {
	// stub
	printf("show_text: %s\n",text);
}

// seg009:04FF
void __pascal far show_text_with_color(rect_type far *rect_ptr,int x_align,int y_align,char far *text,int color) {
	//short saved_textcolor;
	//saved_textcolor = textstate.textcolor;
	//textstate.textcolor = color;
	show_text(rect_ptr, x_align, y_align, text);
	//textstate.textcolor = saved_textcolor;
}

// seg009:3A91
void __pascal far set_curr_pos(int xpos,int ypos) {
	// stub
}

// seg009:0C44
void __pascal far show_dialog(char *text) {
	// stub
	puts(text);
}

// seg009:053C
int __pascal far input_str(const rect_type far *rect,char *buffer,int max_length,const char *initial,int has_initial,int arg_4,int color,int bgcolor) {
	// stub
	strncpy(buffer, "dummy input text", max_length);
	return strlen(buffer);
}

#endif // USE_TEXT

// seg009:37E8
void __pascal far draw_rect(const rect_type far *rect,int color) {
	method_5_rect(rect, blitters_0_no_transp, color);
}

// seg009:3985
surface_type far *__pascal rect_sthg(surface_type *surface,const rect_type far *rect) {
	// stub
	return surface;
}

// seg009:39CE
rect_type far *__pascal shrink2_rect(rect_type far *target_rect,const rect_type far *source_rect,int delta_x,int delta_y) {
	target_rect->top    = source_rect->top    + delta_y;
	target_rect->left   = source_rect->left   + delta_x;
	target_rect->bottom = source_rect->bottom - delta_y;
	target_rect->right  = source_rect->right  - delta_x;
	return target_rect;
}

// seg009:3BBA
void __pascal far restore_peel(peel_type peel_ptr) {
	//printf("restoring peel at (x=%d, y=%d)\n", peel_ptr.rect.left, peel_ptr.rect.top); // debug
	method_6_blit_img_to_scr(peel_ptr.peel, peel_ptr.rect.left, peel_ptr.rect.top, /*0x10*/0);
	free_peel(&peel_ptr);
	//SDL_FreeSurface(peel_ptr.peel);
}

// seg009:3BE9
peel_type __pascal far read_peel_from_screen(const rect_type far *rect) {
	// stub
	peel_type result;
	memset(&result, 0, sizeof(result));
	result.rect = *rect;
#ifndef USE_ALPHA
	SDL_Surface* peel_surface = SDL_CreateRGBSurface(0, rect->right - rect->left, rect->bottom - rect->top, 24, 0xFF, 0xFF<<8, 0xFF<<16, 0);
#else
	SDL_Surface* peel_surface = SDL_CreateRGBSurface(0, rect->right - rect->left, rect->bottom - rect->top, 32, 0xFF, 0xFF<<8, 0xFF<<16, 0xFF<<24);
#endif
	if (peel_surface == NULL) {
		sdlperror("SDL_CreateRGBSurface");
		quit(1);
	}
	result.peel = peel_surface;
	rect_type target_rect = {0, 0, rect->right - rect->left, rect->bottom - rect->top};
	method_1_blit_rect(result.peel, /*surface*/current_target_surface, &target_rect, rect, 0);
	return result;
}

// seg009:3D95
int __pascal far intersect_rect(rect_type far *output,const rect_type far *input1,const rect_type far *input2) {
	short left = MAX(input1->left, input2->left);
	short right = MIN(input1->right, input2->right);
	if (left < right) {
		output->left = left;
		output->right = right;
		short top = MAX(input1->top, input2->top);
		short bottom = MIN(input1->bottom, input2->bottom);
		if (top < bottom) {
			output->top = top;
			output->bottom = bottom;
			return 1;
		}
	}
	memset(output, 0, sizeof(rect_type));
	return 0;
}

// seg009:4063
rect_type far * __pascal far union_rect(rect_type far *output,const rect_type far *input1,const rect_type far *input2) {
	short top = MIN(input1->top, input2->top);
	short left = MIN(input1->left, input2->left);
	short bottom = MAX(input1->bottom, input2->bottom);
	short right = MAX(input1->right, input2->right);
	output->top = top;
	output->left = left;
	output->bottom = bottom;
	output->right = right;
	return output;
}

// seg009:7214
void __pascal far stop_sounds() {
	// stub
}

// seg009:7220
void __pascal far play_sound_from_buffer(void far *buffer) {
	// stub
}

// seg009:7273
void __pascal far turn_sound_on_off(char uk1) {
	// stub
	is_sound_on = uk1;
}

// seg009:7299
int __pascal far check_sound_playing() {
	// stub
	return 0;
}

// seg009:38ED
void __pascal far set_gr_mode(char grmode) {
	if (SDL_Init(SDL_INIT_VIDEO | SDL_INIT_TIMER) != 0) {
		sdlperror("SDL_Init");
		quit(1);
	}
	SDL_EnableUNICODE(1);
	Uint32 flags = 0;
	int fullscreen = check_param("full") != 0;
	if (fullscreen) flags |= SDL_FULLSCREEN;
	onscreen_surface_ = SDL_SetVideoMode(320, 200, 24, flags);
	if (onscreen_surface_ == NULL) {
		sdlperror("SDL_SetVideoMode");
		quit(1);
	}
	if (fullscreen) {
		SDL_ShowCursor(SDL_DISABLE);
	}
	SDL_WM_SetCaption("Prince of Persia (SDL)", NULL);
	graphics_mode = gmMcgaVga;
#ifdef USE_TEXT
	load_font();
#endif
}

// seg009:9289
void __pascal far set_pal_arr(int start,int count,const rgb_type far *array,int vsync) {
	// stub
	int i;
	for (i = 0; i < count; ++i) {
		if (array) {
			set_pal(start + i, array[i].r, array[i].g, array[i].b, vsync);
		} else {
			set_pal(start + i, 0, 0, 0, vsync);
		}
	}
}

rgb_type palette[256];

// seg009:92DF
void __pascal far set_pal(int index,int red,int green,int blue,int vsync) {
	// stub
	//palette[index] = ((red&0x3F)<<2)|((green&0x3F)<<2<<8)|((blue&0x3F)<<2<<16);
	palette[index].r = red;
	palette[index].g = green;
	palette[index].b = blue;
}

// seg009:969C
int __pascal far add_palette_bits(char n_colors) {
	// stub
	return 0;
}

// seg009:97E4
void __pascal far process_palette(void *target,dat_pal_type far *source) {
	// stub
}

// seg009:98F0 ; imghdr_type far *__pascal decode_image_(imghdr_type far *source,char near *xlat_tbl)

// seg009:9C36
int __pascal far find_first_pal_row(int which_rows_mask) {
	word which_row = 0;
	word row_mask = 1;
	do {
		if (row_mask & which_rows_mask) {
			return which_row;
		}
		++which_row;
		row_mask <<= 1;
	} while (which_row < 16);
	return 0;
}

// seg009:9C6C
int __pascal far get_text_color(int cga_color,int low_half,int high_half_mask) {
	if (graphics_mode == gmCga || graphics_mode == gmHgaHerc) {
		return cga_color;
	} else if (graphics_mode == gmMcgaVga && high_half_mask != 0) {
		return (find_first_pal_row(high_half_mask) << 4) + low_half;
	} else {
		return low_half;
	}
}

// seg009:9CAC
//void __pascal far set_loaded_palette(void far *area1_ptr) {
//	// stub
//}

// seg009:9F34
void __pascal far release_dathandle(dat_type far *pointer) {
	dat_type** prev = &dat_chain_ptr;
	dat_type* curr = dat_chain_ptr;
	while (curr != NULL) {
		if (curr == pointer) {
			*prev = curr->next_dat;
			free(curr);
			return;
		}
		curr = curr->next_dat;
		prev = &((*prev)->next_dat);
	}
	// stub
}

// seg009:9F80
void far *__pascal load_from_opendats_alloc(int resource) {
	// stub
	//printf("id = %d\n",resource);
	char image_filename[256];
	int fd = -1;
	dat_type* pointer;
	for (pointer = dat_chain_ptr; fd == -1 && pointer != NULL; pointer = pointer->next_dat) {
		snprintf(image_filename,sizeof(image_filename),"data/%s/res%d.bin",pointer->filename,resource);
		printf("loading (binary) %s",image_filename);
		fd = open(image_filename, O_RDONLY);
	}
	//printf("A\n");
	if (fd == -1) {
		printf(" FAILED\n");
		return NULL;
	}
	printf("\n");
	//printf("B fd = %d\n",fd);
	//printf(" from %s\n", pointer->filename);
	//long size = filelength(fd);
	struct stat buf;
	fstat(fd, &buf);
	long size = buf.st_size;
	void* area = malloc(size);
	//printf("size=%ld, area=%p\n",size,area);
	read(fd, area, size);
	close(fd);
	//printf("C\n");
	return area;
}

// seg009:A172
int __pascal far load_from_opendats_to_area(int resource,void far *area,int length) {
	// stub
	return 0;
}

// SDL-specific implementations

void rect_to_sdlrect(const rect_type* rect, SDL_Rect* sdlrect) {
	sdlrect->x = rect->left;
	sdlrect->y = rect->top;
	sdlrect->w = rect->right - rect->left;
	sdlrect->h = rect->bottom - rect->top;
}

void __pascal far method_1_blit_rect(surface_type near *target_surface,surface_type near *source_surface,const rect_type far *target_rect, const rect_type far *source_rect,int blit) {
	SDL_Rect src_rect;
	rect_to_sdlrect(source_rect, &src_rect);
	SDL_Rect dest_rect;
	rect_to_sdlrect(target_rect, &dest_rect);
	/*
	if (blit == blitters_0_no_transp) {
		SDL_Rect dest_rect2 = dest_rect;
		// SDL_FillRect modifies the rect!
#ifndef USE_ALPHA
		SDL_FillRect(target_surface, &dest_rect2, SDL_MapRGB(current_target_surface->format, 0, 0, 0));
#else
		SDL_FillRect(target_surface, &dest_rect2, SDL_MapRGBA(current_target_surface->format, 0, 0, 0, SDL_ALPHA_TRANSPARENT));
#endif
	}
	*/
	if (blit == blitters_0_no_transp) {
		// Disable transparency.
		if (SDL_SetColorKey(source_surface, 0, 0) != 0) {
			sdlperror("SDL_SetColorKey");
			exit(1);
		}
	} else {
		// Enable transparency.
		if (SDL_SetColorKey(source_surface, SDL_SRCCOLORKEY, 0) != 0) {
			sdlperror("SDL_SetColorKey");
			exit(1);
		}
	}
	if (SDL_BlitSurface(source_surface, &src_rect, target_surface, &dest_rect) != 0) {
		sdlperror("SDL_BlitSurface");
		quit(1);
	}
	if (target_surface == onscreen_surface_) {
		SDL_UpdateRect(onscreen_surface_, 0, 0, 0, 0); // debug
	}
	//SDL_Delay(10);
}

image_type far * __pascal far method_3_blit_mono(image_type far *image,int xpos,int ypos,int blitter,byte color) {
	SDL_Surface* colored_image;
	int w = image->w;
	int h = image->h;
	colored_image = SDL_CreateRGBSurface(SDL_SRCALPHA, w, h, 32, 0xFF, 0xFF<<8, 0xFF<<16, 0xFF<<24);
	//SDL_Rect rect = {0, 0, image->w, image->h};
	if (SDL_BlitSurface(image, NULL, colored_image, NULL) != 0) {
		sdlperror("SDL_BlitSurface");
		quit(1);
	}
	if (SDL_LockSurface(colored_image) != 0) {
		sdlperror("SDL_LockSurface");
		quit(1);
	}
	int y,x;
	rgb_type palette_color = palette[color];
	uint32_t rgb_color = SDL_MapRGB(colored_image->format, palette_color.r<<2, palette_color.g<<2, palette_color.b<<2) & 0xFFFFFF;
	int stride = colored_image->pitch;
	for (y = 0; y < h; ++y) {
		uint32_t* pixel_ptr = (uint32_t*) ((byte*)colored_image->pixels + stride * y);
		for (x = 0; x < w; ++x) {
			// set RGB but leave alpha
			*pixel_ptr = (*pixel_ptr & 0xFF000000) | rgb_color;
			++pixel_ptr;
		}
	}
	SDL_UnlockSurface(colored_image);
	method_6_blit_img_to_scr(colored_image, xpos, ypos, 0x10);
	SDL_FreeSurface(colored_image);
	return image;
}

const rect_type far * __pascal far method_5_rect(const rect_type far *rect,int blit,byte color) {
	SDL_Rect dest_rect;
	rect_to_sdlrect(rect, &dest_rect);
	rgb_type palette_color = palette[color];
#ifndef USE_ALPHA
	uint32_t rgb_color = SDL_MapRGB(current_target_surface->format, palette_color.r<<2, palette_color.g<<2, palette_color.b<<2);
#else
	uint32_t rgb_color = SDL_MapRGBA(current_target_surface->format, palette_color.r<<2, palette_color.g<<2, palette_color.b<<2, color == 0 ? SDL_ALPHA_TRANSPARENT : SDL_ALPHA_OPAQUE);
#endif
	SDL_FillRect(current_target_surface, &dest_rect, rgb_color);
	if (current_target_surface == onscreen_surface_) {
		SDL_UpdateRect(onscreen_surface_, 0, 0, 0, 0); // debug
	}
	//SDL_Delay(10);
	return rect;
}

void blit_xor(SDL_Surface* target_surface, SDL_Rect* dest_rect, SDL_Surface* image, SDL_Rect* src_rect) {
	if (dest_rect->w != src_rect->w || dest_rect->h != src_rect->h) {
		printf("blit_xor: dest_rect and src_rect have different sizes\n");
		quit(1);
	}
	SDL_Surface* helper_surface = SDL_CreateRGBSurface(0, dest_rect->w, dest_rect->h, 24, 0xFF, 0xFF<<8, 0xFF<<16, 0);
	if (helper_surface == NULL) {
		sdlperror("SDL_CreateRGBSurface");
		quit(1);
	}
	SDL_Surface* image_24 = SDL_ConvertSurface(image, helper_surface->format, 0);
	//SDL_CreateRGBSurface(0, src_rect->w, src_rect->h, 24, 0xFF, 0xFF<<8, 0xFF<<16, 0);
	if (image_24 == NULL) {
		sdlperror("SDL_CreateRGBSurface");
		quit(1);
	}
	SDL_Rect dest_rect2 = *src_rect;
	// Read what is currently where we want to draw the new image.
	SDL_BlitSurface(target_surface, dest_rect, helper_surface, &dest_rect2);
	if (SDL_LockSurface(image_24) != 0) {
		sdlperror("SDL_LockSurface");
		quit(1);
	}
	if (SDL_LockSurface(helper_surface) != 0) {
		sdlperror("SDL_LockSurface");
		quit(1);
	}
	int size = helper_surface->h * helper_surface->pitch;
	int i;
	byte *p_src = image_24->pixels;
	byte *p_dest = helper_surface->pixels;
/*
	int fd;
	fd = creat("xor_src.raw", O_WRONLY);
	write(fd, p_src, size);
	close(fd);
	fd = creat("xor_dst.raw", O_WRONLY);
	write(fd, p_dest, size);
	close(fd);
*/
	// Xor the old area with the image.
	for (i = 0; i < size; ++i) {
		*p_dest ^= *p_src;
		++p_src; ++p_dest;
	}
	SDL_UnlockSurface(image_24);
	SDL_UnlockSurface(helper_surface);
	// Put the new area in place of the old one.
	SDL_BlitSurface(helper_surface, src_rect, target_surface, dest_rect);
	SDL_FreeSurface(image_24);
	SDL_FreeSurface(helper_surface);
	if (target_surface == onscreen_surface_) {
		SDL_UpdateRect(onscreen_surface_, 0, 0, 0, 0); // debug
	}
}

image_type far * __pascal far method_6_blit_img_to_scr(image_type far *image,int xpos,int ypos,int blit) {
	if (image == NULL) {
		printf("method_6_blit_img_to_scr: image == NULL\n");
		quit(1);
	}
	if (blit == blitters_9_black) {
		method_3_blit_mono(image, xpos, ypos, blitters_10h_transp, 0);
		return image;
	}
	SDL_Rect src_rect;
	src_rect.x = 0;
	src_rect.y = 0;
	src_rect.w = image->w;
	src_rect.h = image->h;
	SDL_Rect dest_rect;
	dest_rect.x = xpos;
	dest_rect.y = ypos;
	dest_rect.w = image->w;
	dest_rect.h = image->h;
	if (blit == blitters_3_xor) {
		blit_xor(current_target_surface, &dest_rect, image, &src_rect);
		return image;
	}
	/*
	if (blit == blitters_0_no_transp) {
		SDL_Rect dest_rect2 = dest_rect;
		// SDL_FillRect modifies the rect!
#ifndef USE_ALPHA
		SDL_FillRect(current_target_surface, &dest_rect2, SDL_MapRGB(current_target_surface->format, 0, 0, 0));
#else
		SDL_FillRect(current_target_surface, &dest_rect2, SDL_MapRGBA(current_target_surface->format, 0, 0, 0, SDL_ALPHA_TRANSPARENT));
#endif
	}
	*/
	if (blit == blitters_0_no_transp) {
		// Disable transparency.
		if (SDL_SetColorKey(image, 0, 0) != 0) {
			sdlperror("SDL_SetColorKey");
			exit(1);
		}
	} else {
		// Enable transparency.
		if (SDL_SetColorKey(image, SDL_SRCCOLORKEY, 0) != 0) {
			sdlperror("SDL_SetColorKey");
			exit(1);
		}
	}
	/*{ // debug
		SDL_Rect dest_rect2 = dest_rect;
		// SDL_FillRect modifies the rect!
		SDL_FillRect(current_target_surface, &dest_rect2, SDL_MapRGB(current_target_surface->format, 255, 0, 0));
	}*/
	if (SDL_BlitSurface(image, &src_rect, current_target_surface, &dest_rect) != 0) {
		sdlperror("SDL_BlitSurface");
		quit(1);
	}
	if (current_target_surface == onscreen_surface_) {
		SDL_UpdateRect(onscreen_surface_, 0, 0, 0, 0); // debug
	}
	//SDL_Delay(10);
	return image;
}

// seg009:68CC
void far *__pascal method_7_alloc(int size) {
	if (size >= 0xFFFE) {
		return NULL;
	} else {
		return malloc_far(size);
	}
}

// seg009:68E9
void __pascal far method_8_free(void far *pointer) {
	free_far(pointer);
}

#ifndef USE_COMPAT_TIMER
int fps = 60;
SDL_TimerID timer_handles[2] = {0,0};
int timer_stopped[2] = {1,1};
#else
int wait_time[2] = {0,0};
#endif

void remove_timer(int timer_index) {
#ifndef USE_COMPAT_TIMER
	if (timer_handles[timer_index]) {
		if (SDL_RemoveTimer(timer_handles[timer_index])) {
			timer_handles[timer_index] = NULL;
		} else {
			printf("timer_handles[%d] = %p\n", timer_index, timer_handles[timer_index]);
			sdlperror("SDL_RemoveTimer");
			//quit(1);
		}
	}
#endif
}

Uint32 timer_callback(Uint32 interval, void *param) {
	SDL_Event event;
	memset(&event, 0, sizeof(event));
	event.type = SDL_USEREVENT;
	event.user.code = 'TIME';
	event.user.data1 = param;
	SDL_PushEvent(&event);
#ifndef USE_COMPAT_TIMER
	int timer_index = (int)param;
	remove_timer(timer_index);
	return 0;
#else
	return interval;
#endif
}

void __pascal start_timer(int timer_index, int length) {
	//return; // debug
	// stub
#ifndef USE_COMPAT_TIMER
	if (timer_handles[timer_index]) {
		remove_timer(timer_index);
		timer_handles[timer_index] = NULL;
	}
	timer_stopped[timer_index] = length<=0;
	if (length <= 0) return;
	SDL_TimerID timer = SDL_AddTimer(length*1000/fps, timer_callback, (void*)timer_index);
	if (timer == NULL) {
		sdlperror("SDL_AddTimer");
		quit(1);
	}
	timer_handles[timer_index] = timer;
#else
	wait_time[timer_index] = length;
#endif
}

void idle() {
	SDL_Event event;
	if (SDL_WaitEvent(&event) == 0) {
		sdlperror("SDL_WaitEvent");
		quit(1);
	}
	switch (event.type) {
		case SDL_KEYDOWN:
			last_key = event.key.keysym.unicode;
			if (!last_key) {
				if (event.key.keysym.sym < SDLK_NUMLOCK) {
					last_key = event.key.keysym.scancode << 8;
				}
			}
			key_states[event.key.keysym.sym] = 1;
		break;
		case SDL_KEYUP:
//			key_states[event.key.keysym.sym] = (event.type==SDL_KEYDOWN ? 0x01 : 0x00);
			key_states[event.key.keysym.sym] = 0;
		break;
		case SDL_ACTIVEEVENT:
			// In case the user switches away while holding a key: do as if all keys were released.
			// (DOSBox does the same.)
			if (event.active.state == SDL_APPINPUTFOCUS && event.active.gain == 0) {
				memset(key_states, 0, sizeof(key_states));
			}
		break;
		case SDL_USEREVENT:
			if (event.user.code == 'TIME' /*&& event.user.data1 == (void*)timer_index*/) {
#ifndef USE_COMPAT_TIMER
				timer_stopped[(int)event.user.data1] = 1;
#else
				int index;
				for (index = 0; index < 2; ++index) {
					if (wait_time[index] > 0) --wait_time[index];
				}
#endif
			}
		break;
		case SDL_QUIT:
			quit(0);
		break;
	}
}

word word_1D63A = 1;
// seg009:0EA9
int __pascal do_wait(int timer_index) {
	//return; // debug
	//if (timer_handles[timer_index] == NULL) return;
	/*
	while (! timer_stopped[timer_index]) {
		idle();
		do_paused();
	}
	*/
//	while (! timer_stopped[timer_index]) {
	while (! has_timer_stopped(timer_index)) {
	//do {
		idle();
		int key = do_paused();
		if (key != 0 && (word_1D63A != 0 || key == 0x1B)) return 1;
	} //while (! timer_stopped[timer_index]);
	return 0;
}

void __pascal do_simple_wait(int timer_index) {
//	while (! timer_stopped[timer_index]) {
	while (! has_timer_stopped(timer_index)) {
	//do {
		idle();
	} //while (! timer_stopped[timer_index]);
}

#ifdef USE_COMPAT_TIMER
SDL_TimerID global_timer = NULL;
#endif
// seg009:78E9
void __pascal far init_timer(int frequency) {
#ifndef USE_COMPAT_TIMER
	fps = frequency;
#else
	if (global_timer != NULL) {
		if (!SDL_RemoveTimer(global_timer)) {
			sdlperror("SDL_RemoveTimer");
		}
	}
	global_timer = SDL_AddTimer(1000/frequency, timer_callback, NULL);
	if (global_timer == NULL) {
		sdlperror("SDL_AddTimer");
		quit(1);
	}
#endif
}

// seg009:35F6
void __pascal far set_clip_rect(const rect_type far *rect) {
	SDL_Rect clip_rect;
	rect_to_sdlrect(rect, &clip_rect);
	SDL_SetClipRect(current_target_surface, &clip_rect);
}

// seg009:365C
void __pascal far reset_clip_rect() {
	SDL_SetClipRect(current_target_surface, NULL);
}

// seg009:1983
void __pascal far set_bg_attr(int vga_pal_index,int hc_pal_index) {
	// stub
#ifdef USE_FLASH
	//palette[vga_pal_index] = vga_palette[hc_pal_index];
	if (vga_pal_index == 0) {
		/*
		if (SDL_SetAlpha(offscreen_surface, SDL_SRCALPHA, 0) != 0) {
			sdlperror("SDL_SetAlpha");
			exit(1);
		}
		*/
		// Make the black pixels transparent.
		if (SDL_SetColorKey(offscreen_surface, SDL_SRCCOLORKEY, 0) != 0) {
			sdlperror("SDL_SetColorKey");
			exit(1);
		}
		SDL_Rect rect = {0,0,0,0};
		rect.w = offscreen_surface->w;
		rect.h = offscreen_surface->h;
		rgb_type palette_color = palette[hc_pal_index];
		uint32_t rgb_color = SDL_MapRGB(onscreen_surface_->format, palette_color.r<<2, palette_color.g<<2, palette_color.b<<2) /*& 0xFFFFFF*/;
		//SDL_UpdateRect(onscreen_surface_, 0, 0, 0, 0);
		// First clear the screen with the color of the flash.
		SDL_FillRect(onscreen_surface_, &rect, rgb_color);
		//SDL_UpdateRect(onscreen_surface_, 0, 0, 0, 0);
		// Then draw the offscreen image onto it.
		SDL_BlitSurface(offscreen_surface, &rect, onscreen_surface_, &rect);
		// And show it!
		SDL_UpdateRect(onscreen_surface_, 0, 0, 0, 0);
		// Give some time to show the flash.
		if (hc_pal_index != 0) SDL_Delay(1000/60);
		/*
		if (SDL_SetAlpha(offscreen_surface, 0, 0) != 0) {
			sdlperror("SDL_SetAlpha");
			exit(1);
		}
		*/
		if (SDL_SetColorKey(offscreen_surface, 0, 0) != 0) {
			sdlperror("SDL_SetColorKey");
			exit(1);
		}
	}
#endif // USE_FLASH
}

// seg009:07EB
rect_type far *__pascal offset4_rect_add(rect_type far *dest,rect_type far *source,int d_left,int d_top,int d_right,int d_bottom) {
	*dest = *source;
	dest->left += d_left;
	dest->top += d_top;
	dest->right += d_right;
	dest->bottom += d_bottom;
	return dest;
}

// seg009:3AA5
rect_type far *__pascal offset2_rect(rect_type far *dest,rect_type far *source,int delta_x,int delta_y) {
	dest->top    = source->top    + delta_y;
	dest->left   = source->left   + delta_x;
	dest->bottom = source->bottom + delta_y;
	dest->right  = source->right  + delta_x;
	return dest;
}

#ifdef USE_FADE
// seg009:19EF
void __pascal far fade_in_2(surface_type near *source_surface,int which_rows) {
	palette_fade_type far* palette_buffer;
	if (graphics_mode == gmMcgaVga) {
		palette_buffer = make_pal_buffer_fadein(source_surface, which_rows, 2);
		while (fade_in_frame(palette_buffer) == 0) {
			wait(1, 0); // modified
		}
		pal_restore_free_fadein(palette_buffer);
	} else {
		// ...
	}
}

// seg009:1A51
palette_fade_type far *__pascal make_pal_buffer_fadein(surface_type *source_surface,int which_rows,int wait_time) {
	palette_fade_type far* palette_buffer;
	word curr_row;
	word var_8;
	word curr_row_mask;
	palette_buffer = malloc_far(sizeof(palette_fade_type));
	palette_buffer->which_rows = which_rows;
	palette_buffer->wait_time = wait_time;
	palette_buffer->fade_pos = 0x40;
	palette_buffer->proc_restore_free = &pal_restore_free_fadein;
	palette_buffer->proc_fade_frame = &fade_in_frame;
	read_palette_256(palette_buffer->original_pal);
	memcpy_far(palette_buffer->faded_pal, palette_buffer->original_pal, sizeof(palette_buffer->faded_pal));
	var_8 = 0;
	for (curr_row = 0, curr_row_mask = 1; curr_row < 0x10; ++curr_row, curr_row_mask<<=1) {
		if (which_rows & curr_row_mask) {
			memset_far(palette_buffer->faded_pal + (curr_row<<4), 0, sizeof(rgb_type[0x10]));
			set_pal_arr(curr_row<<4, 0x10, NULL, (var_8++&3)==0);
		}
	}
	//method_1_blit_rect(onscreen_surface_, source_surface, &screen_rect, &screen_rect, 0);
	// for RGB
	//method_5_rect(&screen_rect, 0, 0);
	return palette_buffer;
}

// seg009:1B64
void __pascal far pal_restore_free_fadein(palette_fade_type far *palette_buffer) {
	set_pal_256(palette_buffer->original_pal);
	free_far(palette_buffer);
	// for RGB
	method_1_blit_rect(onscreen_surface_, offscreen_surface, &screen_rect, &screen_rect, 0);
}

// seg009:1B88
int __pascal far fade_in_frame(palette_fade_type far *palette_buffer) {
	rgb_type* faded_pal_ptr;
	word start;
	word column;
	rgb_type* original_pal_ptr;
	word current_row_mask;
	void* var_12;
	/**/start_timer(1, palette_buffer->wait_time); // too slow?
	//printf("start ticks = %u\n",SDL_GetTicks());
	--palette_buffer->fade_pos;
	for (start=0,current_row_mask=1; start<0x100; start+=0x10, current_row_mask<<=1) {
		if (palette_buffer->which_rows & current_row_mask) {
			//var_12 = palette_buffer->
			original_pal_ptr = palette_buffer->original_pal + start;
			faded_pal_ptr = palette_buffer->faded_pal + start;
			for (column = 0; column<0x10; ++column) {
				if (original_pal_ptr[column].r > palette_buffer->fade_pos) {
					++faded_pal_ptr[column].r;
				}
				if (original_pal_ptr[column].g > palette_buffer->fade_pos) {
					++faded_pal_ptr[column].g;
				}
				if (original_pal_ptr[column].b > palette_buffer->fade_pos) {
					++faded_pal_ptr[column].b;
				}
			}
		}
	}
	column = 0;
	for (start = 0, current_row_mask = 1; start<0x100; start+=0x10, current_row_mask<<=1) {
		if (palette_buffer->which_rows & current_row_mask) {
			set_pal_arr(start, 0x10, palette_buffer->faded_pal + start, (column++&3)==0);
		}
	}
	
	int h = offscreen_surface->h;
	if (SDL_LockSurface(onscreen_surface_) != 0) {
		sdlperror("SDL_LockSurface");
		quit(1);
	}
	if (SDL_LockSurface(offscreen_surface) != 0) {
		sdlperror("SDL_LockSurface");
		quit(1);
	}
	int y,x,c;
	int on_stride = onscreen_surface_->pitch;
	int off_stride = offscreen_surface->pitch;
	int fade_pos = palette_buffer->fade_pos;
	for (y = 0; y < h; ++y) {
		byte* on_pixel_ptr = (byte*)onscreen_surface_->pixels + on_stride * y;
		byte* off_pixel_ptr = (byte*)offscreen_surface->pixels + off_stride * y;
		for (x = 0; x < on_stride; ++x) {
			//if (*off_pixel_ptr > palette_buffer->fade_pos) *pixel_ptr += 4;
			int v = *off_pixel_ptr - fade_pos*4;
			if (v<0) v=0;
			*on_pixel_ptr = v;
			++on_pixel_ptr; ++off_pixel_ptr;
		}
	}
	SDL_UnlockSurface(onscreen_surface_);
	SDL_UnlockSurface(offscreen_surface);

	SDL_UpdateRect(onscreen_surface_, 0, 0, 0, 0); // debug
		
	/**/do_simple_wait(1); // too slow?
	//printf("end ticks = %u\n",SDL_GetTicks());
	return palette_buffer->fade_pos == 0;
}

// seg009:1CC9
void __pascal far fade_out_2(int rows) {
	palette_fade_type far *palette_buffer;
	if (graphics_mode == gmMcgaVga) {
		palette_buffer = make_pal_buffer_fadeout(rows, 2);
		while (fade_out_frame(palette_buffer) == 0) {
			wait(1, 0); // modified
		}
		pal_restore_free_fadeout(palette_buffer);
	} else {
		// ...
	}
}

// seg009:1D28
palette_fade_type far *__pascal make_pal_buffer_fadeout(int which_rows,int wait_time) {
	palette_fade_type far *palette_buffer;
	palette_buffer = malloc_far(sizeof(palette_fade_type));
	palette_buffer->which_rows = which_rows;
	palette_buffer->wait_time = wait_time;
	palette_buffer->fade_pos = 00; // modified
	palette_buffer->proc_restore_free = &pal_restore_free_fadeout;
	palette_buffer->proc_fade_frame = &fade_out_frame;
	read_palette_256(palette_buffer->original_pal);
	memcpy_far(palette_buffer->faded_pal, palette_buffer->original_pal, sizeof(palette_buffer->faded_pal));
	// for RGB
	method_1_blit_rect(onscreen_surface_, offscreen_surface, &screen_rect, &screen_rect, 0);
	return palette_buffer;
}

// seg009:1DAF
void __pascal far pal_restore_free_fadeout(palette_fade_type far *palette_buffer) {
	surface_type* surface;
	surface = current_target_surface;
	current_target_surface = onscreen_surface_;
	draw_rect(&screen_rect, 0);
	current_target_surface = surface;
	set_pal_256(palette_buffer->original_pal);
	free_far(palette_buffer);
	// for RGB
	method_5_rect(&screen_rect, 0, 0);
}

// seg009:1DF7
int __pascal far fade_out_frame(palette_fade_type far *palette_buffer) {
	rgb_type* faded_pal_ptr;
	word start;
	word var_8;
	word column;
	word current_row_mask;
	byte* curr_color_ptr;
	var_8 = 1;
	++palette_buffer->fade_pos; // modified
	/**/start_timer(1, palette_buffer->wait_time); // too slow?
	for (start=0,current_row_mask=1; start<0x100; start+=0x10, current_row_mask<<=1) {
		if (palette_buffer->which_rows & current_row_mask) {
			//var_12 = palette_buffer->
			//original_pal_ptr = palette_buffer->original_pal + start;
			faded_pal_ptr = palette_buffer->faded_pal + start;
			for (column = 0; column<0x10; ++column) {
				curr_color_ptr = &faded_pal_ptr[column].r;
				if (*curr_color_ptr != 0) {
					--*curr_color_ptr;
					var_8 = 0;
				}
				curr_color_ptr = &faded_pal_ptr[column].g;
				if (*curr_color_ptr != 0) {
					--*curr_color_ptr;
					var_8 = 0;
				}
				curr_color_ptr = &faded_pal_ptr[column].b;
				if (*curr_color_ptr != 0) {
					--*curr_color_ptr;
					var_8 = 0;
				}
			}
		}
	}
	column = 0;
	for (start = 0, current_row_mask = 1; start<0x100; start+=0x10, current_row_mask<<=1) {
		if (palette_buffer->which_rows & current_row_mask) {
			set_pal_arr(start, 0x10, palette_buffer->faded_pal + start, (column++&3)==0);
		}
	}
	
	int h = offscreen_surface->h;
	if (SDL_LockSurface(onscreen_surface_) != 0) {
		sdlperror("SDL_LockSurface");
		quit(1);
	}
	if (SDL_LockSurface(offscreen_surface) != 0) {
		sdlperror("SDL_LockSurface");
		quit(1);
	}
	int y,x,c;
	int on_stride = onscreen_surface_->pitch;
	int off_stride = offscreen_surface->pitch;
	int fade_pos = palette_buffer->fade_pos;
	for (y = 0; y < h; ++y) {
		byte* on_pixel_ptr = (byte*)onscreen_surface_->pixels + on_stride * y;
		byte* off_pixel_ptr = (byte*)offscreen_surface->pixels + off_stride * y;
		for (x = 0; x < on_stride; ++x) {
			//if (*pixel_ptr >= 4) *pixel_ptr -= 4;
			int v = *off_pixel_ptr - fade_pos*4;
			if (v<0) v=0;
			*on_pixel_ptr = v;
			++on_pixel_ptr; ++off_pixel_ptr;
		}
	}
	SDL_UnlockSurface(onscreen_surface_);
	SDL_UnlockSurface(offscreen_surface);

	SDL_UpdateRect(onscreen_surface_, 0, 0, 0, 0); // debug
	
	/**/do_simple_wait(1); // too slow?
	return var_8;
}

// seg009:1F28
void __pascal far read_palette_256(rgb_type far *target) {
	int i;
	for (i = 0; i < 256; ++i) {
		target[i] = palette[i];
	}
}

// seg009:1F5E
void __pascal far set_pal_256(rgb_type far *source) {
	int i;
	for (i = 0; i < 256; ++i) {
		palette[i] = source[i];
	}
}
#endif // USE_FADE

void set_chtab_palette(chtab_type* chtab, unsigned char* colors, int n_colors) {
	if (chtab != NULL) {
		SDL_Color* scolors = malloc(n_colors*sizeof(SDL_Color));
		int i;
		//printf("scolors\n",i);
		for (i = 0; i < n_colors; ++i) {
			//printf("i=%d\n",i);
			scolors[i].r = *colors << 2; ++colors;
			scolors[i].g = *colors << 2; ++colors;
			scolors[i].b = *colors << 2; ++colors;
		}
		//printf("setcolors\n",i);
		for (i = 0; i < chtab->n_images; ++i) {
			//printf("i=%d\n",i);
			if (chtab->pointers[i] != NULL) {
				if (SDL_SetColors(chtab->pointers[i], scolors, 0, n_colors) != 1) {
					sdlperror("SDL_SetColors");
					quit(1);
				}
			}
		}
		free(scolors);
	}
}

int has_timer_stopped(int index) {
#ifdef USE_COMPAT_TIMER
	return wait_time[index] == 0;
#else
	return timer_stopped[index];
#endif
}
